#!/usr/bin/perl
#$Id: confdef.pl 4849 2014-08-27 17:02:42Z pro $ $URL: svn://svn.setun.net/search/trunk/confdef.pl $

=copyright
PRO-search default configuration
=cut

#
#DO NOT EDIT THIS FILE
#redefine any params in config.pl
#or you can have problems with upgrade
#
#package psconfdef;
#use lib './lib';
#use strict;
use utf8;
#use open ':utf8';
#use encoding "utf8", STDOUT => "utf8", STDIN => "utf8", STDERR => "utf8";
#BEGIN { binmode $_, ':utf8' for *STDIN, *STDOUT, *STDERR; }
our ( %config, %work, %static, $param );
#*psconfdef::config = *main::config;
*config = *main::config;
use lib::abs './lib';
use psmisc;
use pssql;
use warnings;
no warnings qw(uninitialized);
no if $] >= 5.017011, warnings => 'experimental::smartmatch';
#print "Content-type: text/html\n\n" if defined($ENV{'SERVER_PORT'}); # for web dev debug
our $VERSION = '0.19.4'; # . '_' . ( split( ' ', '$Revision: 4849 $' ) )[1];
psmisc::conf(
  sub {
    #$config{'version'} ||= '0.19.1' . '_' . ( split( ' ', '$Revision: 4849 $' ) )[1];
    $config{'version'} ||= $VERSION;
    if   ( $^O =~ /^cygwin/i )                     { $config{'system'} ||= 'cygwin'; }
    if   ( $^O =~ /^(?:(ms)?(dos|win(32|nt)?))/i ) { $config{'system'} ||= 'win'; }
    else                                           { $config{'system'} ||= 'unix'; }
    if ( $config{'system'} eq 'unix' or $config{'system'} eq 'cygwin' ) {
      $config{'slash_sys'}  ||= "/";
      $config{'slash_perl'} ||= "/";
      $config{'mv_command'} ||= 'mv -f';
    }
    if ( $config{'system'} eq 'unix' ) {
      #$config{'rm_command'}	||= 'rm -f';
      $config{'spawn_postfix'} ||= '&';
      #$confi}{'smbclient'}    = '/usr/local/samba/bin/smbclient';
      $config{'smbclient'}  ||= 'smbclient';
      $config{'smb_opt'}    ||= '-d0 -N -UGuest';    # todo user
      $config{'view_opt'}   ||= '-L';
      $config{'smb_ls_opt'} ||= "-c 'recurse;ls'";
      #$config{'get_opt'}	||= '';
      $config{'slash_net'}      ||= "/" x 2;
      $config{'slash_dir'}      ||= "/";
      $config{'share_list_fmt'} ||= 'smb-ls';
      #$config{'log_screen'}   ||= 0;
      #$config{'log_all'}    ||= 0;
      #smb.conf: display charset
      #$config{'cp_share'}     ||= 'koi8-r';
      #$config{'fine'}{'file'}{'cp_res'} ||= 'koi8-r';
      #smb.conf: display charset = UTF8
      $config{'fine'}{'file'}{'cp_res'} ||= 'utf-8';
      #smb.conf: unix charset
      $config{'cp_shell'}       ||= 'koi8-r';
      $config{'cp_log'}         ||= 'koi8-r';
      $config{'local_cmd'}      ||= 'ls';
      $config{'local_list_fmt'} ||= $config{'local_cmd'};
    }
    if ( $config{'system'} eq 'win' ) {
      $config{'slash_net'} ||= "\\" x 2;
      $config{'slash_dir'} ||= "\\";
    }
    if ( $config{'system'} eq 'cygwin' ) {
      $config{'slash_net'} ||= '\\' x 4;
      $config{'slash_dir'} ||= '\\' x 2;
      $config{'cp_shell'}  ||= 'utf-8';
    }
    if ( $config{'system'} =~ /win/ ) {
      $config{'slash_sys'}      ||= "\\";
      $config{'slash_perl'}     ||= "\\";
      $config{'mv_command'}     ||= 'move';
      $config{'dir_cmd'}        ||= 'dir /-c /s';
      $config{'local_cmd'}      ||= $config{'dir_cmd'};
      $config{'starter'}        ||= 'cmd /c';
      $config{'spawn_prefix'}   ||= 'start /min /low';
      $config{'net_view'}       ||= 'net view';
      $config{'share_dos_win'}  ||= 1;
      $config{'share_list_fmt'} ||= 'dir';
      $config{'local_list_fmt'} ||= $config{'share_list_fmt'};
      #$config{'cp_share'}      ||= 'cp866';
      #old f.cked ie
      $config{'fine'}{'file'}{'cp_res'} ||= 'cp866' unless defined $ENV{'REMOTE_ADDR'};
      $config{'cp_shell'}               ||= 'cp1251';
      $config{'cp_log'}                 ||= 'cp866';
      #$config{'log_screen'}    ||= 1;
    }
    $config{'slash_mysql'} ||= '/';
    #del now $^X    $config{'perl'}             ||= 'perl';
    $config{'bzip2'}            ||= 'bzip2';
    $config{'bzip2_uncompress'} ||= '-dqf';    # k
    $config{'direct_unzip'}     ||= 1;         # unzip to parser, without temp files
    $config{'rsync'}            ||= 'rsync';
    $config{'rsync_param'} ||=
      '--compress --list-only --recursive --password-file=tools/rsync_password --timeout=60 --contimeout=20';
    $config{'showmount'}       ||= 'showmount';
    $config{'showmount_param'} ||= '-e';
    $config{'nfs_root'}        ||= '/mnt/nfs';
    $config{'mount'}           ||= 'mount';
    $config{'mount_param'}     ||= '-t nfs -o async,ro,soft,intr,retrans=10,retrycnt=2,timeout=10' if $^O eq 'freebsd';
    $config{'mount_param'}     ||= '-t nfs -o async,ro,soft,intr,retrans=10,retry=1,timeo=100' if $^O eq 'linux';
    $config{'umount'}          ||= 'umount';
    $config{'umount_param'}    ||= '-f';
    $config{'df'}              ||= 'df';
    $config{'df_param'}        ||= '-kiP --no-sync' if $^O eq 'linux';
    $config{'df_param'}        ||= '-nkiT' if $^O eq 'freebsd';
    #$config{'cp_dc_list'}       ||= 'utf-8';
    #$config{'cp_adc'}           ||= 'utf-8';
    #$config{'cp_dchub'}         ||= 'utf-8'; #now in inside dc lib #'cp1251';
    $config{'cp_int'} ||= 'utf-8';    # internal
    $config{'cp_db'}  ||= 'utf-8';    # database
    #$config{'sql'}{'codepage'}        ||= 'cp1251';            # database
    $config{'cp_config'} ||= 'utf-8';    # this config
    #$config{'codepage_default'}         ||= 'utf-8';         # index.cgi output, if automatic detect fail
    $config{'codepage'}              ||= 'utf-8';     # disable automatic detect
    $config{'cp_cache'}              ||= 'utf-8';     # for .js recoding, works only with mod_perl
    $config{'cp_m3u'}                ||= 'cp1251';    #init
    $config{'cp_desc'}               ||= 'cp866';     #init
    $config{'cp_res'}                ||= 'utf-8';
    $config{'fine'}{'ftp'}{'cp_res'} ||= 'cp1251';
    #$config{'fine'}{'http'}{'cp_res'} ||= 'cp1251';
    #$config{'fine'}{'http'}{'cp_res'} ||= 'utf-8';
    #$config{'fine'}{'rsync'}{'cp_res'} ||= 'utf-8';
    $config{'sql'}{'driver'} ||= 'mysql5';            # 'pgpp'
    #$config{'mysql'}                  ||= 'mysql';                                  #'C:/mysql/bin/mysql.exe';
    #$config{'myisamchk'}              ||= 'myisamchk';
    #$config{'mysqlhotcopy'}           ||= 'mysqlhotcopy';
    #$config{'mysqladmin'}             ||= 'mysqladmin';
    $config{'sql_base'} ||= $config{'sql'}{'database'} || $config{'sql'}{'dbname'};
    $config{'sql_base_up'} ||= ( $config{'sql_base'} || 'prosearch' );    #upload
    $config{'sql_base_web'}     ||= $config{'sql_base_up'};     #web
    $config{'sql_base_wup'}     ||= $config{'sql_base_web'};    #web updates
    $config{'sql_tfile'}        ||= 'filebase';
    $config{'sql_tresource'}    ||= 'resource';
    $config{'sql_tpopular'}     ||= 'popular';
    $config{'sql_tranges'}      ||= 'ranges';
    $config{'sql_thost'}        ||= 'host';
    $config{'sql_tbanned'}      ||= 'banned';
    $config{'sql_tquerystat'}   ||= 'querystat';
    $config{'sql_twordstat'}    ||= 'wordstat';
    $config{'sql_tfilestat'}    ||= 'filestat';
    $config{'sql_table_prefix'} ||= '';
    $config{'sql'}{'char_type'} ||= 'VARCHAR';                  #VARCHAR (small and old_mysql_index_BUGgy) or CHAR (fast)
    $config{'sql'}{'auto_check'} ||= 0 if grep { defined $param->{$_} } qw(drop install repair flush);
    $config{'sql'}{'use_fulltext'}  ||= 1;
    $config{'sql'}{'no_empty'}      ||= 1;
    $config{'sql'}{'path_complete'} ||= 1;
    $config{'debug_time'}           ||= 0;
    #touch filename
    #chmod a+w filename
    #!!! OPTIONS FOR Mysql >=5 !!! #  if mysql4 - make undef or ''
    #$config{'sql_default_character_set'} = $config{'sql_set_names'} = 'cp1251';
    #$config{'allow_query_expansion'} = 0;            #    http://dev.mysql.com/doc/refman/5.1/en/fulltext-query-expansion.html
    $config{'sql_varchar_length'} ||= 255;                      # 255 for mysql4 ; 65500 for mysql5
    #!!! end of OPTIONS FOR Mysql >=5 !!!
    #65500
    #for tables install
    if ( $config{'sql'}{'driver'} =~ /pg|sqlite/i ) {
      #$config{'sql_length_prot'}   ||= 5;                       # (1000 mysql / 3 utf)
      #$config{'sql_length_host'}   ||= 64;
      #$config{'sql_length_dcuser'} ||= 32;
      #$config{'sql_length_path'}   ||= 255;
      #$config{'sql_length_name'}   ||= 255;                     # $config{'sql_length_path_index'} =
      #$config{'sql_length_ext'}    ||= 255;
    } elsif ( $config{'cp_db'} =~ /utf-?8?/ ) {                 # maximum primary key length = 333 symbols
      #$config{'sql_length_prot'}   ||= 10;          # (1000 mysql / 3 utf)
      #$config{'sql_length_prot'}   ||= 5;      # (1000 mysql / 3 utf)
      if($config{'sql'}{'key_length'} > 1000) { # freebsd + mariadb 5.5 port option
      $config{'sql_length_prot'}   ||= 8;      # (1000 mysql / 3 utf)
      $config{'sql_length_host'}   ||= 64;
      $config{'sql_length_dcuser'} ||= 32;
      $config{'sql_length_path'}   ||= 255;
      $config{'sql_length_name'}   ||= 255;                     # $config{'sql_length_path_index'} =
      #$config{'sql_length_name'}   ||= 128;        # $config{'sql_length_path_index'} =
      $config{'sql_length_ext'} ||= 64;
	} 

      if ( $config{'use_sphinx'} ) {
        $config{'sql_length_host'} ||= 64;
        $config{'sql_length_name'} ||= 125 - 32;
        $config{'use_type'} //= 1;
      }

if ($config{'sql'}{'key_length'} <= 1000){ 

      $config{'sql_length_host'}   ||= 30;
      $config{'sql_length_dcuser'} ||= 20;
      $config{'sql_length_path'}   ||= 130;
      $config{'sql_length_name'}   ||= 125;                     # $config{'sql_length_path_index'} =
      #$config{'sql_length_name'}   ||= 128;        # $config{'sql_length_path_index'} =
      $config{'sql_length_ext'} ||= 16;
      }
    } else {
      #$config{'sql_length_prot'} ||= ( $config{'sql'}{'char_type'} eq 'VARCHAR' ? 6 : 5 );    #16
      $config{'sql_length_prot'} ||= 5;
      $config{'sql_length_host'} ||= 64;
      #( $config{'sql'}{'char_type'} eq 'VARCHAR' ? 64 : 64 )
      #64 for ip addresses : 111.111.111.111 , or 30-40 for ftp.zssdgfegssdf.com.org.ru
      $config{'sql_length_dcuser'} ||= 32;
      $config{'sql_length_path'}   ||= 182;                     #182 #200
      $config{'sql_length_name'}   ||= 182;                     #182  #200
      $config{'sql_length_ext'}    ||= 64;
    }
    $config{'sql_length_full'} ||= 250;
    #$config{'sql_length_res'}	||= ($config{'sql'}{'char_type'} eq 'VARCHAR' ? $config{'sql_varchar_length'} : 64);
    $config{'sql_length_desc'}    ||= undef;
    $config{'sql_length_content'} ||= undef;
    $config{'sql_length_meta'}    ||= 1024;
    $config{'sql_length_ip'}      ||= 45;                       # 255.255.255.255 0000:0000:0000:0000:0000:0000:192.168.255.255 

    $config{'sql_length_range'}   ||= 128;                      #( $config{'sql'}{'char_type'} eq 'VARCHAR' ? 128 : 128 );
    $config{'sql_length_tiger'}   ||= 39;
    #$config{'sql_length_btih'}      ||= 39;
    $config{'sql_length_word'}       ||= undef;
    $config{'sql_length_path_index'} ||= 128;
    $config{'sql'}{'insert_options'} ||= 'LOW_PRIORITY';        # ; #'DELAYED'
    $config{'sql'}{'update_options'} ||= 'LOW_PRIORITY';
    $config{'sql_web'}               ||= {
      'auto_check'  => 0,
      'auto_repair' => 0,                                       #'error_sleep' => 1, 'error_tries' => 1, 'connect_tries' => 1,
    };
    $config{'sql'}{'connect_tries'} = 1000 unless $ENV{'SERVER_PORT'};
    #$config{'row_default'}{'not null'} = 1;
    $config{'row_all'}{'not null'} = 1;
    my $order = 9999;
    $config{'row'} ||= {
      'prot' => {
        'type'       => $config{'sql'}{'char_type'},
        'length'     => $config{'sql_length_prot'},
        'length_max' => 5,
        'primary'    => 1,
        'index'      => 3,
        #'order'		=> --$order,
        #GDIS 'array_insert' => 1,
        'nav_field' => 1,
        'q_skip'    => 1,
        'row'       => 1,
        'default'   => '',
      },
      'host' => {
        'type'       => $config{'sql'}{'char_type'},
        'length'     => $config{'sql_length_host'},
        'length_max' => 64,
        'primary'    => 1,
        'index'      => 16,
        #'order'		=> --$order,
        'sort' => 1, 'sort_min' => 1,
        #GDIS 'array_insert' => 1,
        'insert_min' => 1,
        'nav_field'  => 1,
        'row'        => 1,
        'fast_not'   => 1,
        'default'    => '',
      },
      'port' => {
        'type' => ( $config{'sql'}{'UNSIGNED'} ? 'SMALLINT' : 'INT' ),
        'primary'  => 1,
        'index'    => 1,
        'unsigned' => 1,
        #'param'   => 'UNSIGNED NOT NULL',
        #'order'   => --$order,
        'not null' => 1,
      },
      'dcuser' => {
        'type'       => $config{'sql'}{'char_type'},
        'length'     => $config{'sql_length_dcuser'},
        'length_max' => 32,
        'primary'    => 1,
        'index'      => 8,
        #'order'		=> --$order,
        'sort' => 1, 'sort_min' => 1, 'row' => 1,
        #GDIS 'array_insert' => 1,
        'nav_field' => 1,
        #?        'insert_min'   => 1,
        'default' => '', 'q_skip' => 1,
        #'row'            => 1,
      },
      'path' => {
        'type'       => $config{'sql'}{'char_type'},
        'length'     => $config{'sql_length_path'},
        'length_max' => 255,
        'primary'    => 1,
        #'hash' => 'hash',
        'index' => $config{'sql_length_path_index'},
        #'param'   => 'NOT NULL',
        #'order'		=> --$order,
        'sort' => 1, 'sort_min' => 1,
        #GDIS 'array_insert'   => 1,
        'nav_field'      => 1,
        'row'            => 1,
        'no_split_space' => 1,
        'q_skip'         => 1,
        'default'        => '',
      },
      'name' => {
        'type'       => $config{'sql'}{'char_type'},
        'length'     => $config{'sql_length_name'},
        'length_max' => 255,
        'primary'    => 1,
        #'hash' => 'hash',
        'index' => 32,
        #'param'   => 'NOT NULL',
        #'order'   => --$order,
        'sort' => 1, 'sort_min' => 1,
        #GDIS 'array_insert'   => 1,
        'nav_field'      => 1,
        'row'            => 1,
        'no_split_space' => 1,
        'default'        => '',
      },
      'ext' => {
        'type'       => $config{'sql'}{'char_type'},
        'length'     => $config{'sql_length_ext'},
        'length_max' => 255,
        'primary'    => 1,
        #'hash' => 'hash',
        'index' => 8,
        #'fulltext'=> 'fulltexti',
        #'param'   => 'NOT NULL',
        #'order'   => --$order,
        'sort' => 1,
        #GDIS 'array_insert' => 1,
        'nav_field' => 1,
        'q_skip'    => 1,
        'row'       => 1,
        'default'   => '',
      },
      'param' => {
        'type'       => $config{'sql'}{'char_type'},
        'length'     => $config{'sql_length_param'},
        'length_max' => 4096,
        'primary'    => 1,
        #'hash' => 'hash',
        #'index' => 10,
        #'fulltext'=> 'fulltexti',
        #'param'   => 'NOT NULL',
        #'order'   => --$order,
        #'sort' => 1,
        #GDIS 'array_insert' => 1,
        #'nav_field' => 1,
        'row'     => 1,
        'default' => '',
      },
      'size' => {
        'type'     => 'BIGINT',
        'index'    => 1,
        'unsigned' => 1,          #NOT NULL
        #'order'   => --$order,
        'sort' => 1,
        #'array_insert'  => 1,
        'sort_min'      => 1,
        'nav_num_field' => 1,
        'allow_count'   => 1,
        'row'           => 1,
        'default'       => 0,
        'not null'      => 1,
      },
      'time' => {
        'type'     => 'INT',
        'index'    => 1,
        'unsigned' => 1,       # NOT NULL
        #'order'   => --$order,
        'sort' => 1,
        #GDIS 'array_insert' => 1,
        'sort_min' => 1,
        #'nav_hide'	=> 1,
        'nav_num_field' => 1,
        'row'           => 1,
        'default'       => 0,
        'not null'      => 1,
      },
      'desc' => {
        'type'   => $config{'sql'}{'char_type'},
        'length' => $config{'sql_length_desc'},
        #'index'   => 1,
        #'fulltext'	=> 'fulltexti',
        #'param'   => 'NOT NULL',
        #GDIS 'array_insert' => 1,
        #'order'   => --$order,
        'row'      => 1,
        'default'  => '',
        'not null' => 1,
      },
      'meta' =>
        { 'type' => $config{'sql'}{'char_type'}, 'length' => $config{'sql_length_meta'}, 'default' => '', 'not null' => 1, },
      'tiger' => {    # if you want to use
        'type'   => $config{'sql'}{'char_type'},    # special row for DC
        'length' => $config{'sql_length_tiger'},    # tiger hashes
        'index'  => 1,
        #'order'   => --$order,
        #GDIS 'array_insert' => 1,
        'sort'     => 1,
        'sort_min' => 1,
        'not null' => 1,
        'default'  => '',
      },
      'content' => {
        'type'   => $config{'sql'}{'char_type'},
        'length' => $config{'sql_length_content'},
        #'row'      => 1,
        'default'  => '',
        'not null' => 1,
      },
      'range' => {
        'type'    => $config{'sql'}{'char_type'},
        'length'  => $config{'sql_length_range'},
        'primary' => 1,
        #'param'   => 'NOT NULL',
        #'order'   => --$order,
        #GDIS 'array_insert' => 1,
        'insert_min' => 1,
      },
      'ip' => {
        'type'       => $config{'sql'}{'char_type'},
        'length'     => $config{'sql_length_ip'},
        'length_max' => 15,
        'index'      => 15,
        #'param'   => 'NOT NULL',
        #'order'   => --$order,
        #GDIS 'array_insert' => 1,
        'default'  => '',
        'not null' => 1,
      },
      'counter' => {
        'type'     => 'INT',
        'index'    => 1,
        'unsigned' => 1,       # NOT NULL
        #'order'   => --$order,
        #'array_insert'	=> 1,
        'allow_count'   => 1,
        'sort'          => 1,
        'sort_min'      => 1,
        'nav_num_field' => 1,
        'row'           => 1,
        'not null'      => 1,
      },
      'full' => {
        'type'       => $config{'sql'}{'char_type'},
        'length'     => $config{'sql_length_full'},
        'length_max' => 4096,
        'primary'    => 1,
        #GDIS 'array_insert' => 1,
        #'order'		=> --$order,
        'insert_min' => 1,
        'not null'   => 1,
      },
      'id' => {
        'type'           => 'BIGINT',
        'unsigned'       => 1,          #NOT NULL
        'default'        => 0,
        'not null'       => 1,
        'auto_increment' => 1,
      },
      'int' => {
        'type'     => 'INT',
        'unsigned' => 1,                #NOT NULL
        'default'  => 0,
        'not null' => 1,
      },
      'bigint' => {
        'type'     => 'BIGINT',
        'unsigned' => 1,                #NOT NULL
        'default'  => 0,
        'not null' => 1,
      },
    };
    #$config{'row'}
    #sub row { return { %{$config{'row'}{shift @_} }, 'order' => --$order, @_} }
    my $row ||= $config{'row_call'} ||= sub { return { %{ $config{'row'}{ shift @_ } }, 'order' => --$order, @_ }; };
    #TODO!!!    #to enable every file voting
    #$config{'table'}{$config{'sql_tfile'}}{$_} = $config{'table'}{$config{'sql_thost'}}{$_} for (qw(voteu voted lastip));
    #for my $table (($config{'sql_tfile'}, $config{'sql_tresource'})) { for my $field ('voteu','voted') {
    #delete($config{'sql'}{'table_join'}{$table}{$config{'sql_thost'}}{'fields'}{$field}); } }
    $config{'use_dc'} //= $config{'use_dc_only'};
    $config{'use_stem'} //= $config{'use_stem_only'} // 1;
    if ( $config{'use_sphinx'} ) {
      $config{'use_stem'} = 0;
      #$config{'no_plus_minus'} = 1;
    }
    $config{'sql'}{'table'} ||= {
      $config{'sql_tfile'} => {
        ( $config{'use_sphinx'} ? ( 'id' => $row->( 'id', 'primary' => 1 ) ) : () ),
        'prot' => $row->('prot'),
        ( $config{'use_user'} ? ( 'user' => $row->('user') ) : () ),
        ( $config{'use_pass'} ? ( 'pass' => $row->('pass') ) : () ),
        'host' => $row->( 'host', 'q_skip' => 1, 'weight' => 7, ),
        ( $config{'use_port'} ? ( 'port' => $row->('port') ) : () ),
        ( $config{'use_dc'} ? ( 'dcuser' => $row->( 'dcuser', 'weight' => 6, ) ) : () ),
        'path' => $row->( 'path', 'weight'   => 10, ),
        'name' => $row->( 'name', 'fulltext' => 'fulltexti', 'weight' => 9, ),
        'ext'  => $row->( 'ext',  'fulltext' => 'fulltexti', 'weight' => 8, ),
        ( $config{'use_http'} ? ( 'param' => $row->('param') ) : () ),
        ( $config{'use_dc'} ? ( 'tiger' => $row->( 'tiger', 'q_skip' => 1, 'weight' => 11, ) ) : () ),
        ( $config{'use_type'} ? ( 'type' => $row->( 'int', 'nav_num_field' => 1, ) ) : () ),
        'size' => $row->('size'),
        'time' => $row->( 'time', 'nav_hide' => 1, ),
        'desc' => $row->( 'desc', 'fulltext' => 'fulltexti', ( $config{'use_content'} ? ( length => 512 ) : () ) ),
        ( $config{'use_content'} ? ( 'content' => $row->( 'content', 'fulltext' => 'fulltexti', ) ) : () ),
        #'meta' => $row->( 'desc', 'row' => 0, 'length'     => 1024,),
        'meta' => $row->( 'meta', ),
        'scan' => $row->( 'time', 'purge' => 1, 'nav_hide' => 1, 'nav_num_field' => 0, ),
        'dl'   => $row->('counter'),                                                        # ?
        'voteu'  => $row->( 'counter', 'nav_num_field' => 0, 'nav_hide' => 1, ),
        'voted'  => $row->( 'counter', 'nav_num_field' => 0, 'nav_hide' => 1, ),
        'lastip' => $row->(
          'ip',
          #GDIS 'array_insert'  => 0,
        ),
        'added' => pssql::row(
          'added',                                                                          #GDIS 'array_insert'  => 1,
          'nav_num_field__' => 0,
          '__nav_hide'      => 1,
        ),                                                                                  #'index' => 1,
        ( $config{'use_stem'} ? ( 'stem' => pssql::row( 'stem', ) ) : () ),
        #( $config{''} ? ( 'stem' => pssql::row( 'stem', ) ) : () ),
      },
      $config{'sql_tresource'} => {
        'prot' => $row->('prot'),
        ( $config{'use_user'} ? ( 'user' => $row->('user') ) : () ),
        ( $config{'use_pass'} ? ( 'pass' => $row->('pass') ) : () ),
        'host' => $row->('host'),
        ( $config{'use_port'} ? ( 'port'   => $row->('port') )   : () ),
        ( $config{'use_dc'}   ? ( 'dcuser' => $row->('dcuser') ) : () ),
        'path'   => $row->('path'),
        'time'   => $row->( 'time', 'purge' => 1, ),
        'scan'   => $row->('time'),
        'period' => $row->('time'),
        'files'  => $row->('counter'),
        'dirs'   => $row->('counter'),
        'size'   => $row->('size'),
        'dl'     => $row->('counter'),
        'added'  => pssql::row(
          'added',
          #GDIS 'array_insert' => 1,
        ),
        #'added'  => $row->('time'),
        ( $config{'use_dc'} ? ( 'cid' => $row->( 'tiger', ) ) : () ),
      },
      $config{'sql_thost'} => {
        'host' => $row->('host'),
        ( $config{'use_dc'} ? ( 'dcuser' => $row->('dcuser') ) : () ),
        'ip'    => $row->('ip'),
        'port'  => $row->( 'port', 'primary' => 0, ),
        'time'  => $row->( 'time', 'purge' => 1, ),
        'scan'  => $row->('time'),
        'files' => $row->('counter'),
        'dirs'  => $row->('counter'),
        'size'  => $row->('size'),
        'dl'    => $row->('counter'),
        'added' => pssql::row(
          'added',
          #GDIS 'array_insert' => 1,
        ),
        #'added'  => $row->('time'),
        'voteu'  => $row->('counter'),
        'voted'  => $row->('counter'),
        'lastip' => $row->(
          'ip',
          #GDIS 'array_insert' => 0,
        ),
        'meta' => $row->( 'meta', ),
      },
      $config{'sql_tranges'} => {
        'range'  => $row->('range'),
        'time'   => $row->( 'time', 'purge' => 1, ),
        'scan'   => $row->('time'),
        'alive'  => $row->('time'),
        'size'   => $row->( 'size', 'type' => 'INT', ),
        'period' => $row->('time'),
        #'added'  => $row->('time'),
        'added' => pssql::row(
          'added',    #GDIS 'array_insert' => 1,
        ),
        'desc' => $row->('desc'),
        'meta' => $row->( 'meta', length => 4096 ),
      },
      $config{'sql_tbanned'} => {    # for future NOT used now
        'prot' => $row->('prot'),
        #?      ($config{'use_user'} ? ('user' => $row->('user')) : ()),
        #?      ($config{'use_pass'} ? ('pass' => $row->('pass')) : ()),
        'host' => $row->('host'),
        #?      ($config{'use_port'} ? ('port' => $row->('port')) : ()),
        #?      ($config{'use_dc'} ? ('dcuser' => $row->('dcuser')) : ()),
        'reason' => $row->('desc'),
        #'added'  => $row->('time'),
        'added' => pssql::row(
          'added',                   #GDIS 'array_insert' => 1,
        ),
      },
      $config{'sql_tquerystat'} => {
        'query' => $row->(
          'desc',
          'primary'        => 1,
          'fulltext'       => 'fulltexti',
          'nav_hide'       => 1,
          'insert_min'     => 1,
          'no_split_space' => 1,
          'q'              => 1,
        ),
        'top'     => $row->( 'counter', 'default' => 1, ),
        'results' => $row->('bigint'),
        'last'    => $row->( 'time',    'purge'   => 1, ),
        'lastip'  => $row->('ip'),
        ( $config{'use_stem'} ? ( 'stem' => pssql::row( 'stem', ) ) : () ),
      },
      $config{'sql_twordstat'} => {
        'word'   => $row->( 'desc',    'primary' => 1, 'insert_min' => 1, ),
        'top'    => $row->( 'counter', 'default' => 1, ),
        'last'   => $row->( 'time',    'purge'   => 1, ),
        'lastip' => $row->('ip'),
      },
      $config{'sql_tfilestat'} => {
        'file'   => $row->('full'),
        'meta'   => $row->('meta'),
        'size'   => $row->('size'),
        'dl'     => $row->('counter'),
        'last'   => $row->( 'time', 'purge' => 1, ),
        'lastip' => $row->('ip'),
      },
    };
    if ( $config{'use_sphinx'} ) {
      $_->{unique} = 'uniq', delete $_->{primary},
        for grep { $_->{primary} and !$_->{auto_increment} } values %{ $config{'sql'}{'table'}{ $config{'sql_tfile'} } };
      $config{'sql'}{'table'}{ $config{'sql_tfile'} }{$_}{'length'} =
        $config{'sql'}{'table'}{ $config{'sql_tfile'} }{$_}{'length_max'} = undef
        for qw(desc);
      delete $config{'sql'}{'table'}{ $config{'sql_tfile'} }{$_}{'fulltext'} for qw(desc content), qw( name ext);
      $config{'sql'}{'table'}{ $config{'sql_tfile'} }{$_}{'sphinx'} = 1 for qw(desc name ext), ($config{'use_content'} ? 'content' : ());
    }
    for my $table ( keys %{ $config{'sql'}{'table'} } ) {
      for my $row ( sort { $config{'sql'}{'table'}{$table}{$b}{'order'} <=> $config{'sql'}{'table'}{$table}{$a}{'order'} }
        keys %{ $config{'sql'}{'table'}{$table} } )
      {
        $config{'sql'}{'table'}{$table}{$row}{'default'} = 0,
          if $config{'sql'}{'table'}{$table}{$row}{'type'} =~ /INT/i
            and !defined $config{'sql'}{'table'}{$table}{$row}{'default'};
      }
      #}
      #for my $table (keys %{ $config{'sql'}{'table'} }) {
      $config{'sql'}{'table_param'}{$table}{'purge'} = $_
        for grep { $config{'sql'}{'table'}{$table}{$_}{'purge'} } keys %{ $config{'sql'}{'table'}{$table} };
    }
    $config{'sql'}{'table_param'}{ $config{$_} }{'sql_insert_num'} ||= 1 for ( 'sql_tranges', 'sql_thost', 'sql_tresource' );
    $config{'sql'}{'table_param'}{ $config{'sql_tfile'} }{'no_auto_repair'} = 1;   # only with $config{'auto_repair_selected'}=1
    $config{'sql'}{'table_join'} ||= {
      $config{'sql_tfile'} => {
        $config{'sql_thost'} => {
          #'using' => {'host'=>1,}, # now auto by primary
          #'on' => {'host'=>'host',}, # DEV todo
          'fields' => {
            'live'     => 'time',
            'hostscan' => 'scan',
            #'voteu'	=> 'voteu',
            #'voted'	=> 'voted',
            #'lastip'	=> 'lastip',
            'ip'       => 'ip',
            'hostport' => 'port',
          },
        },
      },
    };
#print "tq=($config{'sql'}{'driver'},",Dumper(\%pssql::default),", $pssql::default{$config{'sql'}{'driver'}})[$pssql::default{$config{'sql'}{'driver'}}{'table quote'}]";
#print "tq=($config{'sql'}{'driver'},",Dumper(\%{pssql::}), Dumper(%{pssql::def});
    for my $table ( keys %{ $config{'sql'}{'table_join'} } ) {
      for my $jt ( keys %{ $config{'sql'}{'table_join'}{$table} } ) {
        push @{ $config{'sql'}{'table_param'}{$table}{'join_fields'} },
          keys %{ $config{'sql'}{'table_join'}{$table}{$_}{'fields'} }
          for keys %{ $config{'sql'}{'table_join'}{$table} };
        @{ $config{'sql'}{'table_param'}{$table}{'name_to_base'} }{
          keys %{ $config{'sql'}{'table_join'}{$table}{$_}{'fields'} } } =
          #(map "$jt.$_", values %{$config{'sql'}{'table_join'}{$table}{$_}{'fields'}})
          (
          map {
            #$config{'sql'}{ $config{'sql_driver'} }
            $pssql::default{ $config{'sql'}{'driver'} }{'table quote'}
              . $jt
              . $config{'sql'}{'table_prefix'}
              . $pssql::default{ $config{'sql'}{'driver'} }{'table quote'} . '.'
              . $pssql::default{ $config{'sql'}{'driver'} }{'row quote'}
              . $_
              . $pssql::default{ $config{'sql'}{'driver'} }{'row quote'}
          } values %{ $config{'sql'}{'table_join'}{$table}{$_}{'fields'} }
          ) for keys %{ $config{'sql'}{'table_join'}{$table} };
        #print join ',',%{$config{'sql'}{'table_param'}{ $table }{'name_to_base'}};
      }
    }
    %{ $config{'sql'}{'table_join'}{ $config{'sql_tresource'} }{ $config{'sql_thost'} }{'fields'} } =
      %{ $config{'sql'}{'table_join'}{ $config{'sql_tfile'} }{ $config{'sql_thost'} }{'fields'} };
    #dev
    #%{ $config{'sql'}{'table_join'}{ $config{'sql_tresource'} }{ $config{'sql_thost'} }{'on'} } =
    #%{ $config{'sql'}{'table_join'}{ $config{'sql_tfile'} }{ $config{'sql_thost'} }{'on'} };
    $config{'sql'}{'table_join'}{ $config{'sql_tresource'} }{ $config{'sql_thost'} }{'fields'}{$_} ||= $_
      for qw( voteu voted lastip );
#$config{'sql'}{'table_join'}{$config{'sql_thost'}}{$config{'sql_tresource'}}{'fields'}{$_} ||= $_ for qw( voteu voted lastip );
    $config{'clear_file'} ||= { 'path' => undef, 'name' => undef, 'ext' => undef, };
    $config{'module_crawler'} ||= 0;    # use crawler as module
    $config{'module_index'}   ||= 0;    # -/- index   ----//---
    #=============================================================================
    #conf( sub {
    #===Web part==================================================================
    $config{'timediff'} = 0;            #- 60 * 60 * 4; # 4hours
    #$config{'log_screen'} = 1 ; # if $param->{'debug'} and $config{'view'} eq 'html';
    #$config{'log_screen'} = $config{'log_debug'} = $config{'debug'} =
    #$config{'sql_debug'} =
    #2;
    $order = 2;                         # 1 - for directory type id
    #http://www.fileinfo.net/common.php
    $config{'ext'}{'all'}{'order'}     ||= $order++;
    $config{'ext'}{'all'}{'ext'}       ||= [];
    $config{'ext'}{'all'}{'skip_what'} ||= '1';
    #$config{'ext'}{'all'}{'to'}		||= '';
    #$config{'ext'}{'all'}{'no_oneline'}	||= 1;
    $config{'ext'}{'video'}{'ext'} ||=
      [qw(avi mpg mpe mpeg wmv mp2 asf mp2v mp4 m1v m2v ogm nsv vid vob rm mov mkv mp4 bik smk fli divx 3gp swf flv)];    #dat
    #$config{'ext'}{'video'}{'to'}		||= join('|', sort @{ $config{'ext'}{'video'}{'ext'} });
    $config{'ext'}{'video'}{'order'}     ||= $order++;
    $config{'ext'}{'video'}{'can_show'}  ||= 1;
    $config{'ext'}{'video'}{'destroy'}   ||= 1;
    $config{'ext'}{'video'}{'autoclose'} ||= 1;
    $config{'ext'}{'video'}{'new_win'}   ||= 1;
    $config{'ext'}{'video'}{'player'}    ||= 'wmp';
    $config{'ext'}{'audio'}{'ext'} ||=
      [qw(mp3 wma ogg aif aiff au kar mp1 m4a mid midi nsa voc wav ra flac lpac mac mpc ape aac rmi snd)];                #mp4
    $config{'ext'}{'audio'}{'order'}     ||= $order++;
    $config{'ext'}{'audio'}{'can_show'}  ||= 1;
    $config{'ext'}{'audio'}{'destroy'}   ||= 1;
    $config{'ext'}{'audio'}{'autoclose'} ||= 1;
    $config{'ext'}{'audio'}{'new_win'}   ||= 1;
    $config{'ext'}{'audio'}{'player'}    ||= 'wmp';
    $config{'ext'}{'media'}{'ext'}       ||= [ @{ $config{'ext'}{'audio'}{'ext'} }, @{ $config{'ext'}{'video'}{'ext'} } ];
    $config{'ext'}{'media'}{'skip_what'} ||= '1';
    $config{'ext'}{'media'}{'no_type'}   ||= '1';
    $config{'ext'}{'image'}{'ext'} ||=
      [qw(jpg jpeg jpe png jp2 gif bmp emf ico jfif jif tiff tif pic pix pcx tga psd wmf)];    #More! from acdsee
    $config{'ext'}{'image'}{'order'} ||= $order++;
    $config{'ext'}{'image'}{'can_show'} ||= 1;
    $config{'ext'}{'cd'}{'ext'} ||=
      [qw(iso nrg b5i b5t c2d cd cif cue dao dmg gcd gi mds pxi tao vc4 nrg pdi bwt ccd img fcd vcd cdi mdf)];    #bin
    $config{'ext'}{'cd'}{'order'} ||= $order++;
    $config{'ext'}{'archive'}{'ext'} ||=
      [qw(arj rar zip uue ha gz gzip lzh jar bz2 tbz tbz2 tar tgz rpm ace cab 7z msi deb cpio rk)];
    $config{'ext'}{'archive'}{'order'}      ||= $order++;
    $config{'ext'}{'text'}{'ext'}           ||= [qw(chm doc hlp htm html pdf rtf txt wri xls me bbs ion log)];
    $config{'ext'}{'text'}{'order'}         ||= $order++;
    $config{'ext'}{'exec'}{'ext'}           ||= [qw(bat cmd com exe msi sh dll)];
    $config{'ext'}{'exec'}{'order'}         ||= $order++;
    $config{'ext'}{'exec'}{'no_oneline'}    ||= 1;
    $config{'ext'}{'src'}{'ext'}            ||= [qw(c h cpp hpp cc hh cs java js py pl pm asp cgi php xml xsl xslt)];
    $config{'ext'}{'src'}{'order'}          ||= $order++;
    $config{'ext'}{'src'}{'no_oneline'}     ||= 1;
    $config{'ext'}{'playlist'}{'ext'}       ||= [qw(m3u pls)];
    $config{'ext'}{'playlist'}{'order'}     ||= $order++;
    $config{'ext'}{'playlist'}{'can_show'}  ||= 1;
    $config{'ext'}{'playlist'}{'destroy'}   ||= 1;
    $config{'ext'}{'playlist'}{'autoclose'} ||= 1;
    $config{'ext'}{'playlist'}{'player'}    ||= 'wmp';
    $config{'ext'}{'playlist'}{'new_win'}   ||= 1;
    $config{'ext'}{'playlist'}{'skip_what'} ||= 1;
    #$config{'ext'}{'font'}{'ext'} ||= [qw(fnt fon ttf otf)];
    #$config{'ext'}{'font'}{'order'}     ||= $order++;
    $config{'exts'}{'swf'}{'type'}   = 'flash';
    $config{'exts'}{'swf'}{'player'} = 'flash';
    for my $type ( grep { !$_->{no_type} } values %{ $config{'ext'} } ) {
      $config{ext_to_type}{$_} = $type->{order} for @{ $type->{ext} || [] };
    }
    $config{'ext'}{$_}{'type'} = $config{'ext'}{$_}{'order'}, $config{type_to_name}{ $config{'ext'}{$_}{'order'} } = $_
      for grep { !$config{'ext'}{$_}{no_type} } keys %{ $config{'ext'} };
    $config{'when'}{''}       ||= 'always';
    $config{'when'}{7}        ||= 'week';
    $config{'when'}{14}       ||= '2week';
    $config{'when'}{31}       ||= 'month';
    $config{'when'}{91}       ||= '3month';
    $config{'when'}{183}      ||= '6month';
    $config{'when'}{365}      ||= 'year';
    $config{'local_ext_mask'} ||= '';         # PRE CONFDEF # '|(80\.90\.\d+.\d+)';
    $config{'local_mask'} ||=
      '^((10\.\d+\.\d+\.\d+)|(172\.((1[6-9])|(2\d)|(3[01]))\.\d+\.\d+)|(192\.168\.\d+\.\d+)|(127\.\d+\.\d+\.\d+)'
      . $config{'local_ext_mask'} . ')$';
    $config{'web_add_mask'}      ||= $config{'local_mask'};      #'^(\w+\.\w+)+$'; # to allow named servers
    $config{'web_adder_mask'}    ||= $config{'web_add_mask'};    #who can add : only ip
    $config{'web_add_only_ip'}   ||= 0;
    $config{'proxy_server_mask'} ||= $config{'local_mask'};
    $config{'proxy_client_mask'} ||= $config{'local_mask'};
    $order = 1;
    #DEFAULT value for show
    $config{'maxplaylist'} ||= 1000000;
    #deldep    $config{'max_results'} ||= 1000;
    #file for store web access count - must exists with correct privileges
    $config{'count_file'}       ||= $config{'root_path'} . 'count';
    $config{'search_name'}      ||= 'File Search';
    $config{'title'}            ||= $config{'search_name'};
    $config{'rss2_description'} ||= 'new search results';
    #$config{'root_url'}       ||= './';                        # may be full path ? (if apache servername == localhost)
    #look in /usr/share/locale /usr/local/share/locale
    #$config{'locale'} ||= 'ru_RU.CP1251';    #ru_RU.CP866 ru_RU.ISO8859-5 ru_RU.ISO_8859-5 ru_RU.KOI8-R  ru_RU.CP1251
    #win ? #  setlocale(LC_CTYPE, "Russian_Russia.1251"); # ЙМЙ "Russian_Russia.866"
    #$config{'locale'} = 'ru';
    #file mirrors rules
    #Any parametrs
    #$config{'force_param'}{'count_f'} = 'on'; #force counting
    #$config{'force_param'}{'host'} = '10.10.120.10'; # only one host
    $config{'online_minutes'} ||= 80;
    $config{'ping_interval'}  ||= 1200;    # ping from web every
    $config{'ping_timeout'}   ||= 0.3;     # timeout for web pinger
    #time from scan to scan of every resource
    $config{'period'} ||= 3600 * 24 * 3;            # period for resource scan (seconds) 0 if inf
    $config{'fine'}{'range'}{'period'} ||= 3600;    # period for range scan (seconds)
    $config{'purge'} ||= 3600 * 24 * 7;             # delete if not scanned last (seconds). good value is $config{'period'} * 2
    $config{'banned_time'} ||= 3600 * 24 * 60;
    #$config{'unknown_time'}	= 60 * 60 * 24 * 100; # ~3 month ago
    $config{'unknown_time'}       ||= '';                                       # 0!
    $config{'scan_timeout'}       ||= $config{'period'} - ( 3600 * 20 );        # maximum 20 hours of scan
    $config{'scan_range_timeout'} ||= $config{'fine'}{'range'}{'period'} / 2;
    $config{'periodic_time'}      ||= 3600;                                     # period for cycle
    $config{'nothing_scan_sleep'} ||= 60 * 5;
    $config{'purge_by'}           ||= 10000;
    $config{'purges'}             ||= 10000000 / $config{'purge_by'};
    $config{'purge_sleep'}        ||= 1;
    $config{'purge_every_res'}    ||= 0;
    $config{'form_method'}        ||= 'get';                                    # 'get' or 'post'
    $config{'counter_url'}        ||= '';                                       # '' = auto, or url of search (if dynamic ip)
    $config{'enable_xor_query'}   ||= 0;                                        # 0 or 1 : xor - very slow in mysql
    #@{ $config{'name_to_base'} }{ qw(live) }  = qw(host.time);
    #$config{'on_page'}                 ||= 100; #del
    $config{'allow_pinger'} ||= 1;                                              #online web pinger
    #$config{'allow_online'}            ||= 1;          #web: show online selector, color time row
    #$config{'allow_boolean'}           ||= 1;
    #$config{'allow_regex'}             ||= 1;          # allow regex queries	re: ~=
    #$config{'allow_soundex'}           ||= 1;          # allow soundex queries	so: @=
    $config{'allow_search_in_founded'} ||= 1;
    $config{'stupid_hit_counter'}      ||= 1;
    $config{'allow_add'}               ||= 1;
    $config{'allow_vote'} //= 1;
    $config{'allow_query_stat'} ||= 1;
    $config{'no_word'}          ||= 1;
    #$config{'no_query_count'}        ||= 1;
    #$config{'no_query_time'}         ||= 1;
    $config{'no_query_ip'}         ||= 1;          # query last: mobile[172.16.1.17](21s) games[172.16.1.17](2m)
    $config{'allow_web_rescan'}    ||= 0;          # rescan button in add page
    $config{'web_rescan_other'}    ||= 0;          # allow rescan any host (not only my)
    $config{'web_rescan_min_time'} ||= 60 * 60;    # 1 hour
    $config{'allow_topfiles'}      ||= 1;          # top downloaded files
    #del->no_    $config{'allow_cp_detect'}     ||= 1;          # ftp codepage autodetect (need testing)
    $config{'allow_proxy'} ||= 0;                  # proxy downloading via search
    $config{'allow_debug'} ||= 1;                  # web debug  search/?.....&debug=on
    #$config{'allow_cp_select'}	||= 1; # codepage selector
    $config{'allow_ping_user_port'} ||= 0;         # ping dc clients by host and port
    $config{'votes_color'}          ||= 2;         # must be > 1
    #del    $config{'allow_flush'}        ||= 1; #-> $config{'no_flush'}
    #$config{'allow_rewrite'} ||= 0;    #
    $config{'rewrite_pages'}     ||= [qw(add add_submit top topquery main search)];          #stat
    $config{'skip_from_link'}    ||= [qw(what_help where_help when_help prev_query view)];
    $config{'force-http-header'} ||= 0;                                                      # print headers in console ?
#todo $config{'html_head-head'} ||= sub { print qq{<link rel="help" href="$config{'root_url'}boolean.htm" title="', lang('help'), '"/>}; };
    my $imgwh = 'height="15" width="80"';
    $config{'html_footer_bef'} ||= sub {
      print ''
        . ( $config{'sql'}{'driver'} =~ /mysql/i
        ? '<a href="http://mysql.com"><img src="'
          . $config{'img_url'}
          . $config{'img_path'}
          . 'mysql.png" alt="Powered by Mysql" '
          . $imgwh
          . '/></a> '
        : '' )
        . ( $config{'sql'}{'driver'} =~ /^pg/i
        ? '<a href="http://postgresql.org"><img src="'
          . $config{'img_url'}
          . $config{'img_path'}
          . 'postgres.png" alt="Powered by PostgreSQL" '
          . $imgwh
          . '/></a> '
        : '' )
        . ( $config{'sql'}{'driver'} =~ /^sqlite/i
        ? '<a href="http://sqlite.org"><img src="'
          . $config{'img_url'}
          . $config{'img_path'}
          . 'sqlite.png" alt="Powered by SQLite" '
          . $imgwh
          . '/></a> '
        : '' )
        . ( $config{'use_sphinx'}
        ? '<a href="http://sphinxsearch.com"><img src="'
          . $config{'img_url'}
          . $config{'img_path'}
          . 'sphinx.png" alt="Powered by Spinx" '
          . $imgwh
          . '/></a> '
        : '' )
        . (
        defined $ENV{'MOD_PERL'}
        ? '<a href="http://perl.apache.org"><img src="'
          #. $config{'root_dir'}
          . $config{'img_url'} . $config{'img_path'} . 'mod_perl.png" alt="Powered by Mod_Perl" ' . $imgwh . '/></a> '
        : '<a href="http://perl.org"><img src="'
          #. $config{'root_dir'}
          . $config{'img_url'}
          . $config{'img_path'}
          . 'perl.png" alt="Powered by Perl" '
          . $imgwh
          . '/></a> '
        )
        . (
        $ENV{'SERVER_SOFTWARE'} =~ /Apache/i
        ? '<a href="http://httpd.apache.org"><img src="'
          #. $config{'root_dir'}
          . $config{'img_url'}
          . $config{'img_path'}
          . 'apache.png" alt="Powered by Apache" '
          . $imgwh
          . '/></a> '
        : ''
        )
        . '<a href="http://validator.w3.org/check?uri=referer"><img src="'
        #. $config{'root_dir'}
        . $config{'img_url'} . $config{'img_path'} . 'xhtml11.png" alt="Valid XHTML 1.1 Strict" ' . $imgwh . '/></a> '
#. '<a href="http://jigsaw.w3.org/css-validator/check/referer"><img ' . $imgwh        . ' src="'        . $config{'img_url'}        . $config{'img_path'}        . 'css_valid.png" alt="Valid CSS!"/></a> '
        . '<a href="http://validator.w3.org/feed/"><img src="'
        . $config{'img_url'}
        . $config{'img_path'}
        . 'rss_valid.png" alt="[Valid RSS]" title="Valid RSS feed" '
        . $imgwh
        . '/></a> ' . '<br/>';
    };
    $config{'sel_sep'} ||= ' :: ';
    $config{'sel_sep_head'} ||= $config{'sel_sep'};
    #$config{'html_search-form_aft_aft'}	||= '<hr/>';
    #todo $config{'i-search_bef'} ||= sub { '<a href="boolean.htm">' . psmisc::lang('im looking for') . '</a>' };
    $config{'html_res_play_link_bef'} ||= ' &nbsp;&nbsp;';
    #$config{'html_form-custom-links_bef'} = '<a href="../">..</a>';
    #print $config{'sel_sep'},'  if $config{'up_link'}; #and !$config{'client'}_type{'ext'};
    $config{'no_cp-select'} = 1;

=cu
#$config{'style'}	||= 'search1.css';
  $config{'css_list'} = {
#'nocss' => '',
#'zero' => 'search.css',
#'one' => 'search1.css',
#'two' => 'search2.css',
	'base' => 'base.css',
  };
  $config{'css_list_add'} = {};
=cut

    #$config{'style'} = ($param->{'style'} or 'base');
    $config{'css'}                 ||= 'base.css';
    $config{'style_change_reload'} ||= 1;
    $config{'mode'}                ||= 'advanced';
    $config{'modes'}               ||= [qw(simple  advanced)] if $param->{'mode'} and $param->{'mode'} ne 'advanced';  #standard
    #$config{'mode'} ||= 'simple';
    #@{ $config{'styles'} } = qw(white black);
    #$config{'style'} ||= 'white';
    #$config{'css_url'} = $config{'js_url'} = ''; # 'http://css2.heavyloaded.com/search/';
    #$config{'img_url'} ||= 'img/';
    #$config{'img_url'} ||= $config{'root_dir'};
    $config{'img_path'} ||= 'img/';
    $config{'img_ext'}  ||= 'png';
    #hints:
    #$config{'img_trans'}{'avi'} = 'exec'; #change
    #$config{'img_url'} = 'http://img3.heavyloaded.com/search/img/';	# external host
    #$config{'img_external'}{($_ =~ m|/(\w+)\.png$|)[0]} = $_ for <img/*.png>; # for external host
    #win: $config{'img_trans'} generate:
    #perl -e "print q($config{'img_external'}{'), $_ = ($_ =~ m|/(\w+)\.png$|)[0], q('} = '),$_, qq(';\n) for <web/img/*.png>"
    #$config{'client'}= '';
    $config{'img_trans'}{'playlist'} ||= 'audio';
    $config{'img_trans'}{'src'}      ||= 'text';
    $config{'img_trans'}{'png'}      ||= 'gif';
    #$config{'css_list'}{'user defined'} = $config{'style'},
    #$config{'style'} = 'user defined' if !$ENV{'MOD_PERL'} and !$config{'css_list'}{$config{'style'}};
    #$config{'style'} = 'user defined',
    #$config{'css_list'}{'user defined'} = $param->{'style'} if $param->{'style'};
    #$config{'js_list'} ||= [qw(lib/jquery-1.7.2.min.js lib/search1.js lib/player.js lib/lib.js)];
    $config{'js_list'} ||= [qw(http://yandex.st/jquery/1.10.1/jquery.min.js lib/search1.js lib/player.js lib/lib.js)];
    #$config{'allow_null_count'} ||= 0;
    $config{'in_inet'}      ||= 0;
    $config{'disable_slow'} ||= 0;                  # deny slow sort's
    $config{'config_sets'}  ||= [qw(mode style)];
    #@{ $config{'config_user'} } = qw(mode style codepage lang specify on_page);
    $config{'config_user'} ||=
      [ @{ $config{'config_sets'} }, qw(codepage lang specify on_page css css_add show_tiger img player_new_win hide_user) ];
    $config{'user_param'}        ||= [qw()];                                                            #full  img
    $config{'user_param_hidden'} ||= [qw(debug help complex)];                                          #specify? full adv_query
    $config{'param_form'}        ||= [qw(q prot user pass host port dcuser path name ext tiger size )];
    $config{'skip_path'} ||= [ @{ $config{'param_form'} }, qw(time page prev_query view show top go save) ];    #full  hash
    $config{'user_param_founded'} ||= [
      @{ $config{'param_form'} },
      qw(size_mode dl dl_mode search_days_mode search_days glueg gluel order order_mode scan scan_mode type)
    ];    #full  time time_mode
    #@{ $config{'sys_param_founded'} } =	qw(scan);
    #@{ $config{'user_param_result'} } = (@{ $config{'user_param_founded'} }, qw(order); #full  time time_mode
    #@{ $config{'user_param_save'} } = qw(show lang style expert); #advanced
    #@{ $config{'user_param_save_hidden'} } = qw(advanced);
    #print "[$config{'result'}][", grep defined($param->{$_}), @{ $config{'user_param_founded'} },']';
    #print "<br\n><br\n><h1>param1:</h1><br\n><br\n>";	for (sort keys %$param)	{ print "$_ = [$param->{$_}]<br\n>"; } # debug #
    #@{ $config{'param_cookie'} } = qw(lang style on_page mode codepage specify);
    #$config{'no_playlist_link'} = 0;
    $config{'param_config'} ||= [ qw(
        show_tiger
        hide_user
        no_plus_minus
        no_onpage
        no_row_scan
        no_rel_path_link
        no_files_dirs
        no_style-select
        no_where_help
        no_when_help
        no_cp-select
        no_split_link
        no_form-online
        no_dl
        no_form-help
        no_examples
        no_footer
        no_viewas
        )
    ];
    #no_form-adjust
    $config{'param_cookie'} ||= [ @{ $config{'config_user'} }, @{ $config{'param_config'} }, qw(queries dls) ];
    $config{'user_param_disable'} ||= [qw(what_help where_help when_help)];                                             #on_page
    $config{'param_advanced'}     ||= [qw(search_days_mode search_days count_f count_s  search_prev order order_mode)]; #on_page
    #specify
    $config{'param_advanced_num'} ||= [qw(size)];
    $config{'param_trans'}{'tth'} ||= 'tiger';
    $config{'js_config'}          ||= [
      qw(cookie_days cookie_domain root_url play_height play_width destroy_on_hide
        ),
      map { ( "play_height_$_", "play_width_$_", "destroy_on_hide_$_" ) }
        ( grep( { $config{'ext'}{$_}{'can_show'} } keys %{ $config{'ext'} } ), 'flash' )
    ];
    $config{'js_work'}             ||= [qw(dls_string)];
    $config{'js_lang'}             ||= [qw(show hide)];
    $config{'redirect_sleep'}      ||= 0;
    $config{'proisk_ru_link'}      ||= 1;
    $config{'web_max_search_time'} ||= $config{'client_bot'} ? 5 : 60;    #force close after 60 seconds (buggy DB, heavy load)
    $config{'web_max_finish_time'} ||= $config{'client_bot'} ? 5 : 60;    #pinger, update stats
    $config{'destroy_link_top'} = $config{'destroy_link_page'} = $config{'destroy_link_view'} = $config{'destroy_link_sort'} =
      $config{'destroy_link_size'} = $config{'destroy_link_time'} = $config{'destroy_link_lang'} =
      $config{'destroy_link_mode'} = $config{'destroy_link'} = 'YES', $config{'allow_pinger'} = 0,
      #$config{'allow_query_stat'} = 0,
      $config{'action_func'}{'alt'} = sub { }, $config{'gotopage_ba'} = 1, @{ $config{'user_param_hidden'} } = (),
      #,$config{'redirector'} ||= sub { '' }
      $config{'allow_pinger'} = 0, $config{'allow_vote'} = 0, if $config{'client_bot'};
    #$config{'allow_pinger'} = 0 if ( $ENV{'HTTP_USER_AGENT'} and $ENV{'HTTP_USER_AGENT'} =~ /google/i ) or $param->{'testbot'};
    #$config{'allow_pinger'} = 0 if ( $ENV{'HTTP_USER_AGENT'} and $ENV{'HTTP_USER_AGENT'} =~ /google/i ) or $param->{'testbot'};
    $config{'cache_css'} = $config{'cache_js'} = 1
      if ( $ENV{'MOD_PERL'} || $ENV{'FCGI_ROLE'} ) and !$config{'client_bot'};    #|| $ENV{'REDIRECT_URL'}
    $config{'top_res'}       ||= 10;
    $config{'top_res_max'}   ||= 100;
    $config{'top_query_max'} ||= 100;
    #$config{'top'} = ($param->{'top'} or ($config{'top_default'} = 10));
    $config{'res_list_min_size'} ||= 100;                                         # if 1 - show http in top list
    $config{'no_distinct'}       ||= 1;                                           # show distinct field
    $config{'cookie_days'}       ||= 1000;
    #$config{'w3_org_valid'} = 1;
    #$config{'no_split_link'} = 1;
    #$config{'no_plus_minus'} = 1;
    #$config{'no_onpage'} = 1;
    #$config{'no_rel_path_link'} = 1;
    $config{'input_help'} ||= 3;
    $config{'specify'}    ||= 'auto';
    $config{'show_tiger'} ||= 0;
    #%{$config{'use_fulltext'}} = {''};
    #$config{'fulltext'}      ||= [qw(fulltexti)];
    $config{'one_string'} ||= 1;
    #$config{'play_height'} = 300;
    #$config{'play_width'} = '100%';
    #$config{'play_width_image'} = '100%';
    $config{'play_height_playlist'}  = $config{'play_height_audio'}     = 64;
    $config{'play_width_playlist'}   = $config{'play_width_audio'}      = 400;
    $config{'play_width_flash'}      = $config{'play_width_video'}      = 640;
    $config{'play_height_flash'}     = $config{'play_height_video'}     = 480;
    $config{'destroy_on_hide_audio'} = $config{'destroy_on_hide_video'} = $config{'destroy_on_hide_flash'} = 1;
    $config{'play_max'}       ||= '2g';
    $config{'play_max_image'} ||= '10m';
    #$config{'play_max_ftp'} = '100m';
    $config{'img_show_sizes'}     ||= [qw(10k 20k 50k 100k 200k 500k 1m all)];
    $config{'img_show_pause'}     ||= 100;
    $config{'img_show_pause_ftp'} ||= 1000;
    $config{'preset'}             ||= {
      'soft' => {
        'winamp' => {
          'set' => {
            'order'      => 'time',
            'order_mode' => '!',
            'name'       => 'w*amp*',
            'q'          => 'winamp',
            'size_mode'  => 'g',
            'ext'        => 'exe',
            'size'       => '1000000'
          }
        },
        'far' => {
          'set' => {
            'order'      => 'time',
            'order_mode' => '!',
            'size_mode'  => 'g',
            'size'       => '1000000',
            'name'       => 'far*',
            'ext'        => 'exe'
          }
        },
        'winrar' => {
          'set' => {
            'order'      => 'time',
            'order_mode' => '!',
            'name'       => 'wrar*',
            'size_mode'  => 'g',
            'ext'        => 'exe',
            'size'       => '500000'
          }
        },
        'mirc' => {
          'set' => {
            'order'      => 'time',
            'order_mode' => '!',
            'size_mode'  => 'g',
            'size'       => '1000000',
            'name'       => 'mirc*',
            'ext'        => 'exe'
          }
        },
        'opera' => {
          'set' => { 'order' => 'time', 'order_mode' => '!', 'name' => 'o8* | o9* | ow32* | Opera_*_Setup', 'ext' => 'exe', }
        },
        'firefox' => { 'set' => { 'order' => 'time', 'order_mode' => '!', 'name' => 'Firefox Setup *', 'ext' => 'exe', } },
        'nero'    => {
          'set' =>
            { 'order' => 'time', 'order_mode' => '!', 'size' => '10m', 'ext' => 'exe', 'q' => 'nero', 'size_mode' => 'g' }
        },
        'klcodec' => { 'set' => { 'order' => 'time', 'order_mode' => '!', 'name' => 'klcodec*', 'ext' => 'exe', } },
        'apexdc' => { 'set' => { 'order' => 'time', 'order_mode' => '!', 'name' => 'ApexDC++_*_setup | ApexDC++_*_binary' } },
      }
    };
    $order = 0;
    $config{'preset'}{'what'}{'all'} ||= { 'order' => ++$order, 'type' => '',  'set' => { 'ext' => '', 'size' => '' } };
    $config{'preset'}{'what'}{'dir'} ||= { 'order' => ++$order, 'type' => '1', 'set' => { 'ext' => '', 'size' => '0' } };
    #================================================================================
    #});
    #===crawler======================================================================
    $config{'datadir'} ||= ( $config{'root_path'} or '.' . $config{'slash_sys'} ) . 'var';
    $config{'tmpdir'}  ||= ( $config{'root_path'} or '.' . $config{'slash_sys'} ) . 'tmp';
    $config{'stop_file'} ||= $config{'datadir'} . '/stop.now';
    #Spawn crawlers (parallel) or linear scan
    $config{'spawn'} ||= 1;
    #How many linear scans start with one crawler process
    $config{'start_by'}         ||= 1;
    $config{'scan_sleep'}       ||= 5;         # randomized pause between resource scans
    $config{'delete_from_base'} ||= 0;         #not fully suported
    $config{'nmap'}             ||= 'nmap';    # or full path ?
    #-v : starts scans before nmap ends
    $config{'nmap_param'} ||= '-vv --open -PE';    #-PN
    #-n : Never do DNS resolution
    $config{'nmap_nores'} ||= '-n';
    $config{'nmap_ping'}  ||= '-sP';
    $config{'nmap_scan'}  ||= '-sS'
      ; # -sS = fastest scan, -S $myip = if nmap does not work ( scanning 10.10.120.1-50 ..sendto in send_ip_raw: sendto(...) => Permission denied)
    # -sA = ACK fast too
    $config{'nmap_param_port'} ||= '-p';
    #$config{'skip_path_mask'} = ''; # only recurse - skip on scan
    #del    $config{'ipdbname'} ||= 'ipdb';
    $config{'work_ext'} ||= '.work';
    #!!
    $config{'output'} ||= $param->{'output'} || 'sql' || 'txt';
    $config{'nodesc'} ||= '(' . join(
      ')|(', qw (
        Desc\S*\s*NA
        Description\s+not\s+available
        )
    ) . ')';
    #DEL  $config{'file_scanned'} = 'scanned';
    $config{'file_banned'} ||= 'banned';
    #$cachedir = cwd() . '/cache';
    $config{'cachedir'} ||= '';
    #$config{'keep_ok'} = 0; # keep *.ok files
    $config{'crawler_name'} ||=
      'PRO-search Crawler v' . ( $config{'version'} || 'r' . ( split( ' ', '$Revision: 4849 $' ) )[1] );
    $config{'skip_hidden'}           ||= 1;                                    # samba: hide share$ and hidden files , .name
    $config{'ftp_recurse_force'}     ||= 0;                                    # do not try ls-lR
    $config{'ftp_recurse_threshold'} ||= 100;                                  # lines in ls -R
    $config{'ftp_recurse_path_max'}  ||= $config{'sql_length_path'} || 255;    # bytes ( [/z/zz/zzz/zz/z/zz/zzz/zz...])
    $config{'ftp_reconnect_sleep'}   ||= 30;
    $config{'ftp_reconnect_retry'}   ||= 5;
    $config{'ftp_reconnect_max'}     ||= 50;
    $config{'timeout'}               ||= 30;
    $config{'ftp_rec_min_size'}      ||= 10;
    $config{'ftp_rec_max_number'}    ||= 500;
    $config{'ftp_rec_path_dupes'}    ||= 3;                                    # /zzz/path/path/path/ = error
    $config{'max_errors'}            ||= 100;
    $config{'anonymous_user'}        ||= 'anonymous';                          # 'IEUser@'
    $config{'anonymous_pass'}        ||= $config{'crawler_name'};
    $config{'ls_opt'}                ||= '-lRGna';
    $config{'local_opt'} ||= $config{'ls_opt'} if $config{'system'} eq 'unix';
    $config{'interrupt_path_re'}     ||= qr{/proc/\d+/}; # dont scan if. only for file://
    #if yo want draw mrtg graph (total/alive ip's)
    #$config{'mrtg_out'} = '';  #'mrtg.out';
    #graph divide
    $config{'mrtg_online_bytes'} ||= 1000000;                                  #megabyte
    $config{'mrtg_online_files'} ||= 1;                                        #per file
    #stop cycle after first run
    $config{'cycle_once'}     ||= 0;
    $config{'ranges_shuffle'} ||= 0;
    $config{'ranges_reverse'} ||= 0;
    #logging:  file -> write to file and screen ; first - -> NO write to screen ;
## -> log screen ;
    #1 -> as log_default
    #0 -> disable
    #example:
    #-file -> write only to file, NO screen
    #-1 -> write only to default log, NO screen
## -> write only to screen
    $config{'log_screen'} ||= !( $config{'system'} eq 'unix' and $param->{'proc'} );    # main switch
    #print "SRC($config{'system'} = $config{'log_screen'})";
    #print "rp=$config{'root_path'}; $work{'$0'} \n";
    $config{'log_default'} ||= ( $ENV{'SERVER_PORT'} ? '#' : "#crawler.log" );
    #print "ROTP=[$config{'root_path'}]";
    #$config{'log_all'}    ||= 0;                                  # global ANYTHING
    $config{'log_pid'} ||= 1;
    #$config{'log_caller'} ||= 0;
    #$config{'log_micro'}  ||= 0;                                  # microtime
    $config{'log_hint'} ||= $config{'root_path'} . 'hints.log';
    #$config{'log_dbg'}	||= 'debug.log';
    #$config{ 'log_' . $_ } = 1 for grep !defined( $config{ 'log_' . $_ } ), qw(info time warn die err  nmap ftp smb web dc);
    $config{'log_trace'}  ||= 0;
    $config{'log_dmp'}    ||= 0 unless $ENV{'SERVER_PORT'};
    $config{'log_dmpbef'} ||= 0;
    $config{'log_dcdmp'}  ||= 0;
    $config{'log_dcdbg'}  ||= 0;
    $config{'log_sql'}    ||= 0;
    $config{'log_dbg'}    ||= 0;
    $config{'log_dev'}    ||= 0;
    #dev dbg sql
    #and more..
    $config{'state_prefix'} = 'crawler.pl: ';
    #store hosts as dns names
    #!!! DON'T FORGET SET $config{'sql_length_host'} = 40; # or 64
    #variant 1: (nmap resolv)
    #$config{'nmap_nores'} = '';
    #variant 2: (perl resolv)
    #translate ip->host only if ip(host) = ip
    $config{'ip_normalize_pre'}        ||= [qw(ftp)];        #, 'file', 'files'
    $config{'host_by_name_norm'}       ||= 0;
    $config{'host_by_name_norm_force'} ||= 0;
    $config{'norm_skip_host'}          ||= join '|', map {
      local $_ = $_;
      s/\./\\./;
      $_
    } qw(.no-?ip. dns.);
    $config{'noscan'} ||= 0;    # use from command line - do not scan everything, only add ranges/resources to base
    #$config{'nmap_only'} = 0; # for nmap scanner process undef by default
    $config{'reload_every'}            ||= 50;         # proc reload after 50 scans
    $config{'reload_time'}             ||= 3600 * 24;  # proc reload after one day
    $config{'scan_dead'}               ||= 1;          # dead host/ranges = was scanned and have 0 bytes
    $config{'scan_online_res'}         ||= 0;          #scan resources ONLY if they was pinged at last $config{'online_minutes'}
    $config{'scanner'}{'file'}{'port'} ||= 139;
    $config{'scanner'}{'file'}{'view'} ||= 1 unless $config{'client_firefox'} or $config{'client_opera'};
    $config{'scanner'}{'file'}{'scanable'} ||= 1;      #by proc
    $config{'scanner'}{'file'}{'pingable'} ||= 1;      #from web
    #$config{'scanner'}{'file'}{'webadd'}		||= 1;
    $config{'scanner'}{'ftp'}{'port'}     ||= 21;
    $config{'scanner'}{'ftp'}{'view'}     ||= 1;       #allow view images from web (browser support needed)
    $config{'scanner'}{'ftp'}{'scanable'} ||= 1;
    $config{'scanner'}{'ftp'}{'pingable'} ||= 1;
    #$config{'scanner'}{'ftp'}{'webadd'}		||= 1;
    $config{'scanner'}{'http'}{'port'}     ||= 80;
    $config{'scanner'}{'http'}{'view'}     ||= 1;
    $config{'scanner'}{'http'}{'scanable'} ||= 1;
    $config{'scanner'}{'http'}{'pingable'} ||= 1;
    #$config{'scanner'}{'http'}{'webadd'}		||= 1;
    $config{'scanner'}{'dchub'}{'port'} ||= 411;
    #$config{'scanner'}{'dchub'}{'scanable'}	||= 1;	# local'ly by dcbot
    $config{'scanner'}{'dchub'}{'no_nmap'}      ||= 1;      # You can set it to 0, and crawler finds all dc hubs on port 411
    $config{'scanner'}{'dchub'}{'disable_goto'} ||= 1;
    $config{'scanner'}{'dchub'}{'pingable'}     ||= 'ip';
    $config{'scanner'}{'dchub'}{'no_res_stat'}  ||= 1;
    $config{'scanner'}{'dchub'}{'no_web_add'}   ||= 1;
    $config{'scanner'}{'adc'}{'no_nmap'}        ||= 1;
    $config{'scanner'}{'adc'}{'disable_goto'}   ||= 1;
    $config{'scanner'}{'adc'}{'pingable'}       ||= 'ip';
    $config{'scanner'}{'adc'}{'no_res_stat'}    ||= 1;
    $config{'scanner'}{'adc'}{'no_web_add'}     ||= 1;
    $config{'scanner'}{'adcs'}{'no_nmap'}       ||= 1;
    $config{'scanner'}{'adcs'}{'disable_goto'}  ||= 1;
    $config{'scanner'}{'adcs'}{'pingable'}      ||= 'ip';
    $config{'scanner'}{'adcs'}{'no_res_stat'}   ||= 1;
    $config{'scanner'}{'adcs'}{'no_web_add'}    ||= 1;
    #$config{'scanner'}{'dchub'}{'disabled'}	= 1 unless $config{'use_dc'};
    #$config{'scanner'}{'dchub'}{'webadd'}	||= 1;
    $config{'scanner'}{'rsync'}{'port'}     ||= 873;
    $config{'scanner'}{'rsync'}{'scanable'} ||= 1;
    $config{'scanner'}{'rsync'}{'pingable'} ||= 1;
    $config{'scanner'}{'rsync'}{'no_nmap'}  ||= 1;     # if you have many rsync servers - set to 0 to enable autofind
    #$config{'scanner'}{'rsync'}{'webadd'}		||= 1;
    $config{'scanner'}{'nfs'}{'port'} //= 2049;        # CRAWLER NOT IMPLEMENTED
    #config{'scanner'}{'nfs'}{'scanable'} //= 1
    #config{'scanner'}{'nfs'}{'pingable'} //= 1
    $config{'scanner'}{'nfs'}{'no_nmap'} //= 1;        # if you have many nfs servers - set to 0 to enable autofind
    #$config{'scanner'}{'nfs'}{'webadd'}  //= 1;
    $config{'desc'}{'bbs'}{'mask'} ||= 'files\.bbs|descript\.ion';
    $config{'desc'}{'bbs'}{'max'}  ||= 2000000;
    $config{'desc'}{'m3u'}{'mask'} ||= '\.m3u$';
    $config{'desc'}{'m3u'}{'max'}  ||= 2000000;
    $config{'update_scan_every'}   ||= 1000;
    $config{'my_dump_file'}        ||= 'mysql.' . int( time() ) . '.dump';
    #del    $config{'get_file_cache_timeout'} ||= 30;
    $config{'flush_sql_every_res'} ||= 0;

=SQL2 remove from here
    $config{'dbi_err_connection'} ||= [qw( 1 1040 1053 1129 1213 1226 2002 2003 2006 2013 )];
    #del  @{ $config{'dbi_err_retry'} }		= (1317);
    $config{'dbi_err_fatal'}        ||= [qw( 1016 1251 )];                              # 1045,
    $config{'dbi_err_syntax'}       ||= [qw( 1054 1060 1064 1067 1146 1364 1406)];      #maybe all 1045..1075
    $config{'dbi_err_repair'}       ||= [qw( 126  130 144 145 1034 1062 1194 1582 )];
    $config{'dbi_err_install'}      ||= [qw( 1146 1049 )];
    $config{'dbi_err_ignore'}       ||= [qw( 2 )];
    $config{'allow_auto_repair'}    ||= 10;                                             # or number 10-30
    $config{'auto_repair_selected'} ||= 0;                                              # repair all tables
    $config{'allow_auto_install'}   ||= 1;
    $config{'rep_quick'}       ||= 1;            # repair option QUICK
    $config{'rep_ext'}         ||= 0;            # repair option EXTENDED
    $config{'rep_frm'}         ||= 0;            # repair option USE_FRM

=cut 

    #to here
    $config{'max_stat_file_size'} ||= 30 * 1024 * 1024 * 1024;    #30 gig - blue ray iso ? 8)
    $config{'ftp_use_cwd'} ||= 1;                                 # for some dumb servers [pure-ftpd]
    #$config{'nolog_startstop'}	||= 0;
    $config{'max_proc_time'}   ||= 3600 * 12;    # 12 hours
    $config{'del_empty_dir'}   ||= 0;
    $config{'del_empty_dcdir'} ||= 1;
    $config{'res_fast'}        ||= 0;            # disable scan+period order in res select (use if you have >100k res 8)
    $config{'on_interrupt'}    ||= 1;            # restart scan on next start if previous was interrupted
    $config{'local_prot'} = 'file';
    $config{'local_host'} = 'localhost';
    $config{'local_path'} = sub (\$) { $_ = "$config{'local_host'}/$_" for @_; };    #for local only usage
    #================================================================================
    #=== dcppp bot===================================================================
    #$config{'fine'}{'dchub'}{'myip'}   = '10.20.30.40'; # for dc incoming connections
    #$config{'fine'}{'dchub'}{'myport'} ||= 6780 + int(rand(1000));
    #$config{'fine'}{'dchub'}{'dcbot_name'}  ||= 'PROSearch';
    $config{'fine'}{'dchub'}{'Nick'} ||= 'PROSearch';
    $config{fine}{adc}{'filelist_builder'} = $config{fine}{adcs}{'filelist_builder'} =
      $config{fine}{dchub}{'filelist_builder'} = ( join ' ', $^X, $work{'$0'} // $0, 'filelist' );
    $config{'dcbot_pause'} ||= 1;                                                    # pause after each nickname
    #$config{'no_dcbot_upload'}            ||= 1;                   #upload filelists to DB after downloading
    $config{'dcbot_once'}              ||= 0;                                        # scan one times and exit
    $config{'fine'}{'dchub'}{'period'} ||= 60 * 60;                                  #rescan hub every
    $config{'fine'}{'adc'}{'period'}   ||= $config{'fine'}{'dchub'}{'period'};
    $config{'fine'}{'adcs'}{'period'}  ||= $config{'fine'}{'dchub'}{'period'};
    $config{'dcbot_client_period'}     ||= 3 * 24 * 60 * 60;                         #rescan user
    #$config{'dcbot_size_myinfo'} = 1; # get users sizes from myinfo, not from filelist
    #deprecated dcpppbot.pl only:
    #del  $config{'dcbot_sleep'} 	||= 60 * 60 * 1; # sleep after all dchubs scan: 1 hour
    #del  $config{'dchub_period'}	||= 60 * 60;
    $config{'force_ip_collect'} ||= 0;
#ipdig	               	||
#prot://  (  ( user     )(     : pass )@)      (  ip                                )|(   name                                  ) (  :port)
    $config{'dig_find_mask'} ||=
#'(?:(?:\w+://)?(?:(?:[^:@" ]+)(?:\:[^:@" ]+)@)?)?(?:(?:\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3})|(?:(?:[a-zA-Z0-9\-]+)(?:\.[a-zA-Z0-9\-]+)+))(?:\:\d+)?';
'(?:(?:\w+://)?(?:(?:[^:@" ]+)(?:\:[^:@" ]+)@)?)?(?:(?:\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3})|(?:(?:[a-zA-Z0-9\-]+\.)+(?:[a-zA-Z\-]+)))(?:\:\d+)?';
    #dig only ip			    '\w+://(?:(?:[^:@ ]+)(?:\:[^:@ ]+)@)?(?:(?:\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}))(?:\:\d+)?';
    $config{'dig_as_ip'}   ||= 0;
    $config{'dig_no_prot'} ||= 1;
    #$config{'dig_ip_mask'}	||= '^10\.';	# input filter mask (skip real ips)
    $config{'dig_ip_mask'}     ||= $config{'local_mask'};    # input filter mask (skip real ips)
    $config{'dig_prot_add'}    ||= '';                       # output protocol: '' - for ranges or host, 'ftp' - for ftp, ..
    $config{'dig_add_netmask'} ||= 24;                       # output netmask, can be ''
    $config{'dig_add_every'}   ||= 1;
    $config{'dig_not_domain'} ||= [qw(gif php html? js css swf jpe?g dtd zip rar gz bz2)];
  #del  $config{'dig_prot_find'}	= '\w+://';	# input protocol find: '\w+://' - any, 'ftp://' - ftp only, '' - no prot, only ip's
  #for crawler only
    $config{'encode_dc_user_mask'} ||= '[^a-zA-Z0-9()_\-\[\]]';    #url = '[^a-zA-Z0-9\-.()_!,]';
    #$config{'max_errors'} = 3; #nahua?
    $config{'http_max_pages'}     ||= 300;
    $config{'http_max_depth'}     ||= 15;
    $config{'http_next_selector'} ||= \&psmisc::shuffle;                                          #sub { sort @_ };
    $config{'http_avail_types'}   ||= { map { lc $_ => 1 } qw(text/plain text/html text/xml) };
    $config{'http_page_sleep'}    ||= 0.5;
    $config{'http_ext_skip'}      ||= {
      map { lc $_ => 1 } @{ $config{'ext'}{'media'}{'ext'} },
      @{ $config{'ext'}{'image'}{'ext'} },
      @{ $config{'ext'}{'cd'}{'ext'} },
      @{ $config{'ext'}{'archive'}{'ext'} },
      qw(chm doc hlp pdf rtf wri),
      qw(com exe msi dll sys),
      qw(css js),
    };
    $config{'http_ext_force'} ||= { map { lc $_ => 1 } qw(txt htm html cgi pl php php4 php5 shtml phtml), };
    $config{'http_skip'} ||= [
      'location.replace\(.*\/cgi-bin\/utm\/aaa',    # UTM billing
      '<title>DWL-',                                # Dlink AP
      '<title>\s*DES-',                             # Dlink switch
      'Ethernet Switch</title>',                    # D-Link DES-3226S 10/100/1000 Fast Ethernet Switch
      'ProCurve Switch',                            # hp62 - ProCurve Switch 6200yl-24G (J8992A)
      '<title>IEEE802.11b',                         # AP
      'Access Point</title>',                       # AP zcom
      '<title id=titletext>(Under Construction)|(В процессе разработки)</title>',    # MS
      '<title>Test Page for Apache Installation</title>',                                               # empty apache
    ];
    #================================================================================
    #=== lib=========================================================================
    #================================================================================
    #conf( sub {
    #=== Lang========================================================================
    $config{'lang_default'} = 'en';
    $config{'lng_ls'} = $config{'lng_smbls'} = 'en';
    $config{'lng'}{'ru'} ||= {
      #'language-code' => 'RU',
      #'encoding'	=> 'WINDOWS-1251',
      #'html_charset'	=> 'windows-1251',
      'prot'     => 'протокол',
      'host'     => 'хост',
      'path'     => 'путь',
      'name'     => 'имя файла',
      'ext'      => 'расширение',
      'dl'       => 'переходы',
      'dirs'     => 'дир',
      'more'     => 'еще',
      'advanced' => 'расширенный',
      'specify'  => 'уточнить',
      'reset'    => 'сбросить',
      'accurate' => 'точно',
      #'online'	=> 'Онлайн',
      'offline'        => 'Все',
      'search'         => 'Искать',
      'file'           => 'файл',
      'size'           => 'размер',
      'changed'        => 'изменен',
      'scanned'        => 'скан',
      'playlist'       => 'Плейлист',
      'current'        => 'текущее',
      'all'            => 'Все',
      'always'         => 'Всегда',
      'everywhere'     => 'Везде',
      'show images'    => 'Показать картинки',
      'download'       => 'скачать',
      'goto'           => 'перейти',
      'im looking for' => 'Я ищу',
      'error database' => 'Ошибка базы данных',
      'hide'           => 'скрыть',
      'show'           => 'показать',
      #'count'	=> '&sum,',#'Считать',
      'what'       => 'что? - всё',
      'where'      => 'где? - везде',
      'when'       => 'когда? - всегда',
      'how'        => 'как',
      'video'      => 'Видео',
      'audio'      => 'Аудио',
      'image'      => 'Изображения',
      'archive'    => 'Архивы',
      'cd'         => 'CD/DVD',
      'exec'       => 'Исполняемые',
      'text'       => 'Текст',
      'week'       => 'Неделя',
      '2week'      => 'Две недели',
      'month'      => 'Месяц',
      '3month'     => 'Три месяца',
      '6month'     => 'Пол года',
      'year'       => 'Год',
      'my'         => 'У меня',
      'segment'    => 'Сегмент',
      'bigsegment' => 'Сегмент большой',
      'time'       => 'время',
      'days'       => 'дней',
      'bytes'      => 'байт',
      'sort'       => 'Сортировать',
      'reverse'    => 'наоборот',
      #'files'	=> 'файлы',
      #'page'	=> 'Страница',
      'by'                 => 'по',
      'found'              => 'Найдено',
      'files'              => 'файлов',
      'bytes'              => 'байт',
      'in'                 => 'за',
      'seconds'            => 'сек',
      'showed'             => 'показано',
      'page'               => 'страница',
      'from'               => 'из',
      'prev'               => 'Пред',
      'next'               => 'След',
      'description'        => 'описание',
      'goto page'          => 'На страницу',
      'search examples'    => 'Несколько примеров как можно использовать поиск',
      'net view'           => 'Обзор сети',
      'how much'           => 'Сколько здесь',
      'listen music'       => 'Слушать музыку',
      'servers'            => 'Серверы',
      'last'               => 'Последний',
      'black'              => 'черный',
      'white'              => 'белый',
      'net'                => 'сети',
      'add'                => 'добавить',
      'search in internet' => 'Искать в интернете',
      'in found'           => 'в найденном',
      'on page'            => 'на странице',
      'total'              => 'всего',
      'alive'              => 'живые',
      'today'              => 'сегодня',
      'yesterday'          => 'вчера',
      'word top'           => 'Частые слова',
      'query top'          => 'Частые запросы',
      'query last'         => 'Последние запросы',
      'file dl'            => 'Скачали раз',
      'file last'          => 'Скачали недавно',
      'queries'            => 'запросы',
      'my queries'         => 'Мои запросы',
      'my dls'             => 'Мои загрузки',
      'clear'              => 'очистить',
      'vote'               => 'голосовать',
      'voteu'              => 'голоса за',
      'voted'              => 'голоса против',
      #'rate up'	=>	'голосовать за',
      #'rate down'	=>	'голосовать против',
      'rate up' => 'за', 'rate down' => 'против',
      #'rate up'	=>	'за',
      #'rate down'	=>	'против',
      #'magnet'	=>	'dcpp',
      'distinct'                             => 'повторы',
      'sites'                                => 'Сайты',
      'and'                                  => 'и',
      'or'                                   => 'или',
      'main'                                 => 'главная',
      'adjust'                               => 'настроить',
      'apply'                                => 'применить',
      'style'                                => 'стиль',
      'show results'                         => 'результатов на странице',
      'stats'                                => 'статистика',
      'mode'                                 => 'режим',
      'simple'                               => 'простой',
      'standard'                             => 'стандартный',
      'help'                                 => 'помощь',
      'max in bytes or all'                  => 'максимум байт или all',
      'lang'                                 => 'язык',
      'new'                                  => 'Новое',
      'similar requests'                     => 'Похожие запросы',
      'dir'                                  => 'Папки',
      'dchubs'                               => 'Хабы',
      'users'                                => 'Юзеры',
      'results for'                          => 'Результаты для',
      'the database is busy right now'       => 'база данных перегружена',
      'sorry'                                => 'извините',
      'database error'                       => 'ошибка базы данных',
      'reload the page'                      => 'обновите страницу',
      'change your query or try again later' => 'измените запрос или попробуйте пожже',
    };
#you can translate too:
#$config{'lng'}{'ru'}{$_} ||= $_
#for qw(online top hits files dirs scan desc ips resources html m3u rss2 text xml xor = ! alt);
#$config{'trans'}{'cp1251'}	  $config{'trans'}{'koi8-r'}	  $config{'trans'}{'iso8859-5'}  $config{'trans'}{'cp866'}	  $config{'trans'}{'utf-8'}
#$config{'lng'}{'en'}{'language-code'} ||= 'en';
#$config{'lng'}{'en'}{'encoding'}	||= 'ISO-8859-1';
#'html_charset'	=> 'windows-1251',
    $config{'lng'}{''}{'prot_symb'}       ||= '',  $config{'lng'}{''}{'host_symb'}  ||= '://',
      $config{'lng'}{''}{'dcuser_symb'}   ||= '/', $config{'lng'}{''}{'path_symb'}  ||= '',
      $config{'lng'}{''}{'path_symb_alt'} ||= '/', $config{'lng'}{''}{'name_symb'}  ||= '/',
      $config{'lng'}{''}{'ext_symb'}      ||= '.', $config{'lng'}{''}{'tiger_symb'} ||= ' ',
  #$config{'lng'}{$_}{'>'} ||= '&gt;', $config{'lng'}{$_}{'<'} ||= '&lt;',
  #$config{'lng'}{$_}{'darr'} ||= '&darr;', $config{'lng'}{$_}{'uarr'} ||= '&uarr;',
  #$config{'lng'}{$_}{'darr'}	||= '<span style="font-family:Wingdings;">C</span>',
  #$config{'lng'}{$_}{'uarr'}	||= '<span style="font-family:Wingdings;">D</span>',
  #for keys %{ $config{'lng'} };
  #$config{'lng'}{'en'}{'months'} ||= [qw(Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec)];
  #$config{'lng'}{'ru'}{'months'} ||= [qw(Янв Фев Мар Апр Май Июн Июл Авг Сен Окт Ноя Дек)];
  #@{ $config{'lng'}{$_}{'month_table'} }{ @{ $config{'lng'}{$_}{'months'} } } = ( 0 .. 11 ) for  keys %{ $config{'lng'} } ;
  #$config{'lng'}{$_}{'month_table'}{ @{ $config{'lng'}{$_}{'months'} } } = ( 0 .. 11 ) for ( keys %{ $config{'lng'} } );
      $config{'no_form-adjust-win-config'} = 1;    #temporary, todo
    $config{'html_body_params'} ||= 'onload="init();my_getbyid(\'q\').focus();"';
    #$config{'html_view-select_bottom'} = sub {print "$config{'result'} ; $param->{'page'}"};
    #conf( sub {});
    #print "<br\n><br\n><h1>INC:</h1><br\n>";		for (sort keys %INC)	{ print "$_ = $INC{$_}<br\n>"; } # debug #
    #del    $config{'no_ajax'} = 1;                        #dev
    $config{'post_init_once'}{'confdef'} = sub {
      #print "post_init_once::confdef;";
      #print "\n\nPOOOOOOOOOO\n\n";
      #$config{'lng'}{'ru'}{'codepages'} ||= [ keys %{ $config{'trans'} } ];
      #$config{'sql_default_character_set'} = $config{'sql_set_names'} =
      #( $config{'sql'}{ $config{'sql_driver'} }{ $config{'cp_db'} } or $config{'cp_db'} );
      $config{fine}{adc}{sql}{$_} //= $config{sql}{$_}, $config{fine}{adcs}{sql}{$_} //= $config{sql}{$_},
        $config{fine}{dchub}{sql}{$_} //= $config{sql}{$_}
        for grep { defined $config{sql}{$_} } qw(driver log cp codepage);
      local %_ =
        ( ref $config{'sql_base_up'} eq 'HASH' ? %{ $config{'sql_base_up'} } : ( 'database' => $config{'sql_base_up'} ) );
      $_{dbname} = $_{database};
      $config{fine}{adc}{sql}{$_} //= $config{fine}{adcs}{sql}{$_} //= $config{fine}{dchub}{sql}{$_} //= $_{$_} for keys %_;
      $config{'ext'}{$_}{'to'} ||= join( '|', sort @{ $config{'ext'}{$_}{'ext'} } ) for keys %{ $config{'ext'} };
      for my $type ( keys %{ $config{'ext'} } ) {
        for my $ext ( @{ $config{'ext'}{$type}{'ext'} } ) {
          $config{'exts'}{$ext}{'type'} ||= $type;
          $config{'exts'}{$ext}{$_} ||= $config{'ext'}{$type}{$_} for qw(can_show destroy autoclose player new_win);
        }
      }
      my $order = $config{'preset'}{'what'}{'dir'}{'order'};
      for my $field (qw(host ext)) {
        for my $type ( sort { $config{$field}{$a}{'order'} <=> $config{$field}{$b}{'order'} } keys %{ $config{$field} } ) {
          $config{'preset'}{$field}{$type} =
            { %{ $config{$field}{$type} }, 'order' => ++$order, 'set' => { $field => $config{$field}{$type}{'to'} }, };
        }
      }
      for my $set ( sort { length $a && length $b ? $a <=> $b : $a cmp $b } keys %{ $config{'when'} } ) {
        $config{'preset'}{'when'}{ $config{'when'}{$set} } = { 'order' => ++$order, 'set' => { 'search_days' => $set }, };
      }
      if ( $config{'fast'} ) {
        $config{'sql'}{'auto_repair'} = 0;
        $config{'sql'}{'error_tries'} = 0;
        $config{'sql'}{'auto_check'}  = 0;
      }
      if ( $config{'use_dc_only'} ) {
        #$config{'scanner'}{$_}{'disabled'} = 1 for qw(ftp file http rsync);
        #print ("DISA[$_]"),
        $config{'scanner'}{$_}{'disabled'} = 1
          for grep { $_ ne 'dchub' and $_ ne 'adc' and $_ ne 'adcs' } keys %{ $config{'scanner'} };
        #delete $config{'sql'}{'table'}{ $config{'sql_tfile'} }{'time'};
        delete $config{'host'};
        #delete $config{'when'};
        $config{'no_playlist_link'} = 1;
        $config{'sql'}{'table'}{ $config{'sql_tfile'} }{'tiger'}{'nav_field'} = 1;    #maybe in dc too ?
        #$config{'no_search_days'}                                             = 1;
        #$config{'no_when_help'}                                               = 1;
        #$config{'no_where_help'}                                              = 1;
        #@{ $config{'modes'} } = qw(standard advanced);
        #$config{'mode'}         = 'standard';
        $config{'no_img'}       = 1;
        $config{'noscan_range'} = 1;
        #$config{'allow_add'}	= 0;
        $config{'ip_normalize_pre'} ||= [qw(dc dcpp p2p)];
        $config{'no_listen_music'} = 1;
      }
      if ( $config{'use_stem'} ) {
        $config{'sql'}{'stem_version'} ||= $config{'use_stem'};
        $config{'sql'}{'table'}{ $config{'sql_tfile'} }{'name'}{'stem'} =
          $config{'sql'}{'table'}{ $config{'sql_tfile'} }{'ext'}{'stem'} =
          $config{'sql'}{'table'}{ $config{'sql_tfile'} }{'desc'}{'stem'} =
          $config{'sql'}{'table'}{ $config{'sql_tquerystat'} }{'query'}{'stem'} = 1;
        if ( $config{'use_stem_only'} ) {
          $config{'sql'}{'table'}{ $config{'sql_tfile'} }{'path'}{'fulltext'} =
            $config{'sql'}{'table'}{ $config{'sql_tfile'} }{'name'}{'fulltext'} =
            $config{'sql'}{'table'}{ $config{'sql_tfile'} }{'ext'}{'fulltext'} =
            $config{'sql'}{'table'}{ $config{'sql_tfile'} }{'desc'}{'fulltext'} =
            $config{'sql'}{'table'}{ $config{'sql_tquerystat'} }{'query'}{'fulltext'} = undef;
        }
      }
    };
    $config{'post_init_every'}{'confdef'} = sub {
      my ($param) = @_;
      #print "post_init_every::confdef;" ;
      #for lib
      if ( $config{'client_ip'} = $ENV{'REMOTE_ADDR'} ) {
        ( $config{'client_ip_a'}, $config{'client_ip_b'}, $config{'client_ip_c'}, $config{'client_ip_d'} ) =
          $config{'client_ip'} =~ /(\d+)\.(\d+)\.(\d+)\.(\d+)/;
        if ( $config{'client_ip'} =~ /$config{'local_mask'}/ ) {
          $config{'client_local'} = 1;
          unless ( $config{'use_dc_only'} ) {
            $config{'host'}{'everywhere'}{'order'} = $order++;
            $config{'host'}{'everywhere'}{'to'}    = '';
            $config{'host'}{'bigsegment'}{'to'}    = "$config{'client_ip_a'}.$config{'client_ip_b'}.*";
            $config{'host'}{'bigsegment'}{'order'} = $order++;
            $config{'host'}{'segment'}{'to'}       = "$config{'client_ip_a'}.$config{'client_ip_b'}.$config{'client_ip_c'}.*";
            $config{'host'}{'segment'}{'order'}    = $order++;
            $config{'host'}{'my'}{'to'} =
              "$config{'client_ip_a'}.$config{'client_ip_b'}.$config{'client_ip_c'}.$config{'client_ip_d'}";
            $config{'host'}{'my'}{'order'} = $order++;
          }
        }
      }
      $config{'browsers'} ||= [qw(opera firefox chrome safari)];
      my $browsers = join '|', @{ $config{'browsers'} };
      $config{'client'} = 'ie', $config{'client_ie'} = 1
        if $ENV{'HTTP_USER_AGENT'} =~ /MSIE/ and $ENV{'HTTP_USER_AGENT'} !~ /$browsers/i;
      #$config{'client'} = 'opera',   $config{'client_opera'}   = 1 if $ENV{'HTTP_USER_AGENT'} =~ /opera/i;
      #$config{'client'} = 'firefox', $config{'client_firefox'} = 1 if $ENV{'HTTP_USER_AGENT'} =~ /firefox/i;
      $config{'client'} = $_, $config{ 'client_' . $_ } = 1
        for grep { $ENV{'HTTP_USER_AGENT'} =~ /$_/i } @{ $config{'browsers'} };
#$config{'no_download_file_opera'} = $config{'no_download_file_firefox'} =     $config{'no_goto_file_opera'} =      $config{'no_goto_file_firefox'} = 1;
#!$config{ 'no_download_file_' . $_ } = $config{ 'no_goto_file_' . $_ } = 1 for @{ $config{'browsers'} };
      $config{'img_trans'}{'url'} = $config{'img_trans'}{'http'} = $config{'img_trans'}{'html'} = $config{'img_trans'}{'htm'} =
        $config{'client'}
        if $config{'client'};
      $config{'top_query'} ||= ( $config{'client_ie'} ? 10 : 15 );
      $config{'styles'} ||= [ 'white', ( $config{'client_ie'} ? () : ('black') ) ];
      $config{'style'} ||= 'white' if $config{'client_ie'};
      $config{'style'} ||= 'black' unless $config{'client_ie'};
      #modes
      $config{'text_desc_aft_aft'} ||= "\n";
      $config{ 'text_' . $_ . '_aft_aft' } ||= ' ' for qw(full size time);
      $config{'html_form-help_bef_bef'} =
        #!      $config{'html_form-online_bef_bef'} =
        #$config{'html_form-links_aft_aft'} =
        #$config{'html_form-link-advanced_aft_aft'} =
        #$config{'html_form-accurate_bef_bef'} =
        $config{'html_form-link-hide-specify_bef_bef'} = $config{'html_form-lang_bef_bef'} = $config{'sel_sep'};
      #$config{'html_form-custom-links_bef_bef'} .= $config{'sel_sep'};
      #$config{'html_form-help-where-win_bef_bef'} =
      #$config{'html_form-help-when-win_bef_bef'} = ' &nbsp; ';
      $config{'html_form-help-where-div_bef_bef'} = ' &nbsp; ';
      $config{'html_form-help-when-div_bef_bef'}  = ' &nbsp; ';
      $config{'html_form-lang_aft'}               = ']';
      $config{'html_form-lang_bef'}               = '[';
      $config{'html_examples_bef_bef'}            = $config{'html_stat_aft_aft'} = '<hr class="hide" />';
      $config{'html_result-table_param'}          = 'style="width:100%;"' if $config{'result'} or ( $param->{'show'} eq 'top' );
      $config{'no_form-reset'}                    = 1;
      $config{'advanced'}{'no_form-links-stat'}   = $config{'advanced'}{'no_select_describe'} =
        $config{'advanced'}{'no_vote_word'}       = 1;
      1;
      $config{'standard'}{'no_plus_minus'}      = $config{'standard'}{'no_onpage'}     = $config{'standard'}{'no_row_scan'} =
        $config{'standard'}{'no_rel_path_link'} = $config{'standard'}{'no_files_dirs'} = 1;

      if ( $param->{'show'} eq 'stat' or $param->{'page'} eq 'stat' or $config{'rewrite'} eq 'stat' ) {
        $config{'standard'}{'no_form-links-stat'} = 1;
      } else {
        $config{'standard'}{'no_main-topquery'} = $config{'standard'}{'no_main-stat'} = 1;
        #$config{'standard'}{'no_stat'} =
      }
      $config{'standard'}{'html_result-table_param'} = 'style="width:100%;"' if !$param->{'show'};
      #$config{'simple'}{'allow_cp_select'} = 0;
      $config{'standard'}{'no_cp-select'} = 1;
      if ( $param->{'mode'} eq 'standard' or ( !$param->{'mode'} and $config{'mode'} eq 'standard' ) ) {
        $config{'out'}{'rss2'}{'hide'} = 1 unless $param->{'order'};
      }
      %{ $config{'simple'} } = %{ $config{'standard'} };
      #!      $config{'simple'}{'no_stat'} = 1 if $param->{'show'} ne 'stat';
      $config{'simple'}{'no_main-topquery'} = 0;
      $config{'simple'}{'no_main-top-stat'} = 1;
      $config{'simple'}{'no_style-select'}  = 1;
      #$config{'simple'}{'no_stat'} =  1 if $param->{'page'} ne 'stat';
      $config{'simple'}{'one_string'}            = $config{'simple'}{'allow_vote'}            = 0;
      $config{'simple'}{'html_examples_bef_bef'} = $config{'simple'}{'html_examples_aft_aft'} = '<br/>' x 3;
      #$config{'simple'}{'no_form-help-where-win'} =
      #$config{'simple'}{'no_form-help-when-win'} =
      $config{'simple'}{'hide_user'} = $config{'simple'}{'no_where_help'} = $config{'simple'}{'no_when_help'} = 1;
      #? if ($param->{'mode'} eq 'simple') {
      #%{$config{'simple'}} = %{$config{'standard'}};
      #$config{'simple'}{'name.ext_only'} = 1;
      $config{'simple'}{'no_split_link'} =
        #$config{'simple'}{'no_when_help'} =
        #$config{'simple'}{'no_where_help'} =
        $config{'simple'}{'no_form-online'} = $config{'simple'}{'no_dl'} = $config{'simple'}{'no_viewas'} = 1;
      $config{'simple'}{'destroy_link_size'} = $config{'simple'}{'destroy_link_time'} = 'YES';
      $config{'simple'}{'html_action-tab_param'} = 'style="font-size:small;"';
      $config{'simple'}{'specify'}               = 'off';
      if ( !$config{'result'} and !$param->{'show'} ) {
        $config{'simple'}{'html_footer_param'} = $config{'simple'}{'html_header_param'} =
          #$config{'simple'}{'html_examples_param'} = ' style="margin-top:10%;"';
          $config{'simple'}{'html_search-form_aft_aft'} = '';
        #$config{'no_form-links-main'} = 1;
      }
      #}
      %{ $config{'pda'} } = %{ $config{'simple'} };
      $config{'pda'}{'no_form-adjust'} = $config{'pda'}{'no_form-help'} = $config{'pda'}{'no_examples'} =
        $config{'pda'}{'no_footer'} = $config{'pda'}{'no_viewas'} = $config{'pda'}{'no_dl'} = $config{'pda'}{'no_search_days'} =
        $config{'pda'}{'no_count_f'}     = $config{'pda'}{'no_count_size'}  = $config{'pda'}{'no_count_dl'} =
        $config{'pda'}{'no_count_voteu'} = $config{'pda'}{'no_count_voted'} = $config{'pda'}{'no_img'} =
        $config{'pda'}{'no_thislink'}    = $config{'pda'}{'no_br'}          = $config{'pda'}{'no_second_query'} =
        #!$config{'pda'}{'no_placeholder'} =
        #$config{'pda'}{'no_pre-search-form'} =
        $config{'pda'}{'hide'} = $config{'pda'}{'no_js'} = $config{'pda'}{'no_hide'} = $config{'pda'}{'no_view-select'} =
        $config{'pda'}{'no_result_string_img'} = 1;
      $config{'pda'}{'help_dev'} = $config{'pda'}{'cache_css'} = $config{'pda'}{'cache_js'} = $config{'pda'}{'css'} =
        $config{'pda'}{'css_add'} = $config{'pda'}{'allow_distinct'} = 0;
      #$config{'pda'}{'style'} = 'base';
      $config{'pda'}{'black'} = {};
      $config{'style'} = 'pda' if $ENV{'HTTP_USER_AGENT'} =~ /links|lynx/i;
      #=======================# This is redesign example:
      $config{'black'}{'css_add'} = 'newstyle.css';
     #$config{'black'}{'html_view-select_aft_aft'} = sub {print '<div class="header-new-up" >',$config{'search_name'},'</div>'};
###$config{'black'}{'html_view-select_bef_bef'} = '<br/>';
#$config{'black'}{'html_view-select_aft_aft'} = '<hr class="hide" />';
#$config{'black'}{'html_view-select_aft_aft'} = sub {print '<div class="header-new-up" >',$config{'search_name'},'</div>'};
#$config{'black'}{'html_header_bef'} = sub {print '<div class="header-new-up" >',$config{'search_name'},'<div class="header-new-up-desc">',$config{'search_name_desc'},'</div></div>'};
#$config{'black'}{'html_pre-search-form_aft_aft'} = sub {print '<div class="header-new-up" >',$config{'search_name'},'<div class="header-new-up-desc">',$config{'search_name_desc'},'</div></div>'};
#$config{'black'}{'html_search-form_bef_bef'} = sub {print '<div class="header-new-up" >',$config{'search_name'},'<div class="header-new-up-desc">',$config{'search_name_desc'},'</div></div>'};
#$config{'black'}{'html_search-form-input_bef_bef'} =
      $config{'black'}{'html_header_bef'} = sub {
        print q{<div class="header-new-up" onclick="location.href='?'" >}, $config{'search_name'} || $config{'title'},
          '<div class="header-new-up-desc">', psmisc::lang( $config{'search_name_desc'} ), '</div></div>';
      };    #<div class="header-type-select">&nbsp;&nbsp;&nbsp; ftp | dc</div>
#$config{'black'}{'html_header-1_bef_bef'} = sub {print '<div class="header-new-up" >',$config{'search_name'},'<div class="header-new-up-desc">',$config{'search_name_desc'},'</div></div>'};
#$config{'black'}{'html_header-new-2_bef_bef'} = '<hr class="hide" />';
#$config{'black'}{'html_search-form_bef_bef'} = '<hr class="hide" />';
#$config{'black'}{'html_header-1_aft_aft'} = '<hr class="hide" />';
#$config{'black'}{'html_form-help_bef_bef'} ||= sub {
#$config{'no_form-help'} = 1;
#};
#if ($param->{'mode'} eq 'simple' or $work{'mode'} eq 'simple') {
      $config{'what_oneline'} ||= sub {
        #$config{'black'}{'html_form-link-specify_aft_aft'} ||= sub {
        my ( $param, $table, $paramnum, $valuenum ) = @_;
        #$config{'no_what_help'} = 1;
        $config{'no_form-help'} = 1;
        #$config{'html_form-link-specify_aft_aft'} =
        #$config{'html_form-link-hide-specify_bef_bef'} = '</div><div>';
        print '</div>' .    #. '<hr class="hide" />' .
          '<div class="header-new-2">';
        print '<ul  class="help-one-string">';
        for my $preset (qw(what ext)) {
          for my $type (
            sort { $config{'preset'}{$preset}{$a}{'order'} <=> $config{'preset'}{$preset}{$b}{'order'} || $a cmp $b }
            #grep { !$config{'ext'}{$_}{'no_oneline'} } keys %{$config{'preset'}{'what'}}) {
            grep { !$config{'preset'}{$preset}{$_}{'no_oneline'} and !$config{'preset'}{$preset}{$_}{'skip_what'} }
            keys %{ $config{'preset'}{$preset} }
            )
          {
            #next if $config{'ext'}{$type}{'skip_what'};
            psmisc::printu '<li><a href="#" onclick="',
              ( $config{'use_type'} && defined $config{'preset'}{$preset}{$type}{'type'}
              ? (qq{repl('type$paramnum', 'value', '$config{'preset'}{$preset}{$type}{'type'}');})
              : map( { ( 'repl(\'', $_, $paramnum, '\',\'value\',\'', $config{'preset'}{$preset}{$type}{'set'}{$_}, '\');' ) }
                keys %{ $config{'preset'}{$preset}{$type}{'set'} } ) ),
          #' if (my_getbyid(\'ext',$paramnum,'\').value) {menu_hide();show_adv(1);};return false;">', lang($type),'</a>'; #<br/>
              ' menu_hide();/*show_adv(1)*/;hilight(1, this, \'onestring-selected\');return false;" ',
              #($param->{'type'} != $config{'preset'}{$preset}{$type}{'type'}? (): ' class="onestring-selected"'),
              ( $param->{'type'} ne $config{'preset'}{$preset}{$type}{'type'}
              ? ('>')
              : qq{ id="onestring-selected">$config{'jscript_open'}hilight(1, gid('onestring-selected'), 'onestring-selected')$config{'jscript_close'}}
              ), psmisc::lang($type), '</a></li>';    #<br/>
          }
        }

=w    
    for my $type (sort { $config{'ext'}{$a}{'order'} <=> $config{'ext'}{$b}{'order'} } grep { !$config{'ext'}{$_}{'no_oneline'} } keys %{ $config{'ext'} }) { #'all', 
#grep here
      next if $config{'ext'}{$type}{'skip_what'};
#print '<a href="#" onclick="repl(\'ext',$paramnum,'\',\'value\',\'',$config{'ext'}{$type}{'to'},'\'); if (my_getbyid(\'ext',$paramnum,'\').value) {hide_id(\'form-help-what-win\');show_adv(1);};return false;">', lang($type),'</a>'; #<br/>
#print '<a href="#" onclick="repl(\'ext',$paramnum,'\',\'value\',\':',$type,'\'); if (my_getbyid(\'ext',$paramnum,'\').value) {hide_id(\'form-help-what-win\');show_adv(1);};return false;">', lang($type),'</a>'; #<br/>
      print '<a href="#" onclick="repl(\'ext',$paramnum,'\',\'value\',\':',$type,'\'); if (my_getbyid(\'ext',$paramnum,'\').value) {menu_hide();show_adv(1);};hilight(1, this, \'onestring-selected\');return false;">', lang($type),'</a>'; #<br/>

    }
=cut

        print '</div>';
        print '</div><div class="header-new-3">';
      };
      #print " mode=$param->{'mode'}; ";
      if ( $param->{'mode'} eq 'simple' or ( !$param->{'mode'} and $config{'mode'} eq 'simple' ) ) {
        $config{'action_func'}{'fulllink'} ||= sub {
          print $config{'redirector'}->( {
              'go'      => $_[0]->{'full'},
              'cp'      => $_[0]->{'cp'},
              'actname' => psindex::out_bold(
                ( $config{'name.ext_only'} ? join_url( { map { ( $_ => $_[0]->{$_} ) } qw(name ext) } ) : $_[0]->{'full'} ),
                $work{'search_str'}
              )
            }
          );
        };
        $config{'action'}{'download'} = $config{'simple'}{'action'}{'goto'} = {};
        $config{'action_func'}{'alt'} = sub { };
        #$config{'action_func'}{'show'} = $config{'action_func'}{'show'};
        $config{'black'}{'no_form-help'} = 1;
        $config{'black'}{'html_form-link-specify_aft_aft'} ||= $config{'what_oneline'};
      } else {
        $config{'black'}{'html_form-help_bef_bef'} ||= '</div>' . '<hr class="hide" /><div class="header-new-2"><table><tr>';
        $config{'black'}{'html_form-link-specify_aft_aft'} ||= '</td></tr></table></div><div class="header-new-3">';
      }
      #$config{'black'}{'html_form-link-hide-specify_bef_bef'} = 'zz';
      $config{'black'}{'html_form-help-what-div_bef_bef'}   = $config{'black'}{'html_form-help-where-div_bef_bef'} =
        $config{'black'}{'html_form-help-when-div_bef_bef'} = '<td>';
      $config{'black'}{'html_form-help-what-div_aft_aft'}   = $config{'black'}{'html_form-help-where-div_aft_aft'} =
        $config{'black'}{'html_form-help-when-div_aft_aft'} = '</td>';
      $config{'black'}{'html_form-link-hide-specify_bef_bef'} = '<td>';
      #$config{'black'}{'html_form-accurate_bef_bef'} =
      #$config{'black'}{'html_form-i-search-input_aft'} = $config{'black'}{'html_form-online_bef_bef'} = '&nbsp;&nbsp;&nbsp; ';
      $config{'black'}{'html_form-links_bef_bef'} = sub { $config{'sel_sep_'} = $config{'sel_sep'}; $config{'sel_sep'} = ''; };
      $config{'black'}{'html_form-links_aft_aft'}    = sub { $config{'sel_sep'}       = $config{'sel_sep_'}; };
      $config{'black'}{'html_form-i-search_aft_aft'} = sub { $config{'main_q_length'} = undef; };
      $config{'black'}{'html_form-lang_bef_bef'} =
        #$config{'black'}{'html_form-links_bef'} =
        $config{'black'}{'html_form-lang_aft_aft'} = $config{'black'}{'html_form-lang_aft'} =
        $config{'black'}{'html_form-lang_bef'}     = '';
      $config{'black'}{'main_q_length'}                 = 30;
      $config{'black'}{'help_select_div'}               = 1;
      $config{'black'}{'html_form-help-what-win_bef'}   = $config{'black'}{'html_form-help-where-win_bef'} =
        $config{'black'}{'html_form-help-when-win_bef'} = '<div class="help-win">';
      $config{'black'}{'html_form-help-what-win_aft'}   = $config{'black'}{'html_form-help-where-win_aft'} =
        $config{'black'}{'html_form-help-when-win_aft'} = '</div>';
      $config{'black'}{'html_form-help-where-win_bef_bef'} = $config{'black'}{'html_form-help-when-win_bef_bef'} = '';
#$config{'black'}{'html_form-link-pre'} = '<td>';
#$config{'black'}{'html_form-link-post'} = '</td>';
#$config{'black'}{'html_pre-search-form_bef'} = "\n\n\n".'<table><tr><td width="100%"></td>'; #<div width=1 class="pre-search-form-span">
#$config{'black'}{'html_pre-search-form_bottom'} = '</tr></table>'."\n\n\n"; #</div>
      $config{'black'}{'sel_sep_head'} = $config{'black'}{'sel_sep'} = ' &nbsp;&nbsp;&nbsp; ';
      if ( ( $param->{'style'} eq 'black' or $config{'style'} eq 'black' ) and $config{'mode'} ne 'pda' ) {
        $config{'lng'}{'ru'}{'what'}  = 'что';
        $config{'lng'}{'ru'}{'where'} = 'где';
        $config{'lng'}{'ru'}{'when'}  = 'когда';
        $config{'lng'}{'en'}{'what'}  = 'what';
        $config{'lng'}{'en'}{'where'} = 'where';
        $config{'lng'}{'en'}{'when'}  = 'when';
        $config{'lng'}{$_}{'im looking for'} = '' for keys %{ $config{'lng'} };
      }
      #=======================
      $work{'cp_input'} = $config{'cp_int'};
    };
  }
);
#warn Data::Dumper::Dumper \%config, \%main::config;
1;
